clear;
addpath('../functions')
sfolder='./results';
dfolder=('./data/');

load('priors1')
load('results1','irfsave','irfsave1')
tmp=prctile(irfsave,[50 16 84]);
TT=1965.5:0.25:2009.75;
HH=0:39;
d1 = datetime(1965,6,1,8,0,0);
d2 = datetime(2009,9,1,8,0,0);
dd = d1:calquarters(1):d2;
dd=datenum(dd);
figure(1)
subplot(3,3,1);
mesh(HH,TT,squeeze(tmp(1,:,:,1)))
axis tight
xlabel('Horizon');
ylabel('Years');
zlabel('T')
title('Median Response')

subplot(3,3,2)
plotx2(dd',(tmp(:,:,1,1))')
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
datetick('x','keepticks');
xlabel('Years')
title('Response at Horizon 0')
xlim([min(dd) max(dd)]);

subplot(3,3,3)
plotx2(dd',(tmp(:,:,8,1))')
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
datetick('x','keepticks');
xlabel('Years')
title('Response at Horizon 8')
xlim([min(dd) max(dd)]);

%%%%%%%%%%%%%%%%%%%%%

subplot(3,3,4);
mesh(HH,TT,squeeze(tmp(1,:,:,2)))
axis tight
xlabel('Horizon');
ylabel('Years');
zlabel('Y')

subplot(3,3,5)
plotx2(dd',(tmp(:,:,1,2))')
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,1,2))')) max(vec((tmp(:,:,1,2))'))]) 
datetick('x','keepticks');
xlabel('Years')
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,1,2))')) max(vec((tmp(:,:,1,2))'))]) 


subplot(3,3,6)
plotx2(dd',(tmp(:,:,8,2))')
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,8,2))')) max(vec((tmp(:,:,8,2))'))]) 
datetick('x','keepticks');
xlabel('Years')
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,8,2))')) max(vec((tmp(:,:,8,2))'))]) 

%%%%%%%%%%%%%%%%%%%%%%%%%
subplot(3,3,7);
mesh(HH,TT,squeeze(tmp(1,:,:,3)))
axis tight
xlabel('Horizon');
ylabel('Years');
zlabel('G')

subplot(3,3,8)
plotx2(dd',(tmp(:,:,1,3))')
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,1,3))')) max(vec((tmp(:,:,1,3))'))]) 
datetick('x','keepticks');
xlabel('Years')
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,1,3))')) max(vec((tmp(:,:,1,3))'))]) 


subplot(3,3,9)
plotx2(dd',(tmp(:,:,8,3))')
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,8,3))')) max(vec((tmp(:,:,8,3))'))]) 
datetick('x','keepticks');
xlabel('Years')
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,8,3))')) max(vec((tmp(:,:,8,3))'))]) 

