clear
beep off
addpath('..\..\..\functions\')
[data0,names]=xlsread('../../../data/benchmark_tax_1.xls');
T0=40;
data0=data0(T0+1:end,:);
names=names(1,2:end);


data=data0(:,1:end-1);
m_t=data0(:,end)*10;

mid=isnan(m_t(:,1));  %id for missing obs in instrument
tmp=m_t(:,1);
tmp(mid)=0;
datax=[data tmp ];
if sum(mid)>0 %initial estimate for missing instrument data via Kalman filter
    [out,out1]=draw_data_initial1(datax,mid,zeros(1,cols(datax)),eye(cols(datax)),cols(datax),cols(datax)-1,1,0.1);
end






dummy=[];
REPS=100000;
BURN=50000;
SKIP=10;
H=40;
CHECK=1;
maxdraws=1000;
EX=1;
idx=BURN+1:SKIP:REPS;
fsize=length(idx);
N=cols(data);

L=2;
Y=data;
dat0=Y;
X=prepare(data,L);
Y=Y(L+1:end,1:N);
X=X(L+1:end,:);
mid=mid(L+1:end,:);
T=rows(X);
if sum(mid)>0
M=out(L+1:end,end); %intrument 
M0=tmp(L+1:end,:); %instrument withmiss=0
Mx=tmp;
else
M=m_t(L+1:end,:);
Mx=m_t;
end
M=detrend(M,'constant');
%priors for VAR coefficients
LAMDAP=10;
TAUP=10*LAMDAP;
EPSILONP=1/10000;
[yd,xd,b0,s0,S0b,T0]=getdummiestrend(LAMDAP,TAUP,EPSILONP,Y,L,EX);
Y0=[Y;yd];
X0=[X;xd];
bmean=X0\Y0;
res=Y0-X0*bmean;
sigmaold=(res'*res)/(rows(Y0)-cols(X0));
A0= chol(sigmaold,'lower');
bmean=vec(bmean);
bold=bmean;
bold0=bold;
Shat=res'*res;
iscale=invpd(Shat);
%priors for instrument equation
%priors for instrument equation
[ VAR01 ] = runproxysimple( data,Mx,10,L );
btmp=VAR01.et\M;
etmp=M-VAR01.et*btmp;
stmp=(etmp'*etmp)/(T-1);
b0m=btmp; %prior mean
v0m=0.1;  %prior variance
meanv=btmp/2; %prior mean for sig
variancev=0.02;%0.015;%prior variance
S0=2*meanv*(1+(meanv^2)/(variancev^2));
NU0=2*(2+(meanv^2)/(variancev^2));
beta2m=b0m;
sigmam=meanv;


tmp=randn(N,1);
tmp=tmp/norm(tmp);
Qold=tmp';
Qstar=Qold;
% if Qstar(1)<0
%     Qstar=Qstar*-1;
% end


NN=N*(N*L+EX);

if sum(mid)>0
    MISS=1;
else
    MISS=0;
end

if MISS
    %Initial values for the Kalman filter B0/0 when drawing missing data
beta0d=[];
for j=0:L-1
    beta0d=[beta0d [Y(L-j,:) M(L-j,:)]];
end
P00d=eye(cols(beta0d));  %P[0/0]
end




% save(strcat(sfolder,filesep,'priors1'))
%storage
bmat=zeros(fsize,NN);
smat=zeros(fsize,N,N);

bmatm=zeros(fsize,1);
smatm=zeros(fsize,1);
qsave=zeros(fsize,N);
irfsave=zeros(fsize,H,N);
fvsave=irfsave;
esave=zeros(fsize,T);

naccept=0;
naccept2=0;
tic;
gibbs1=1;
gibbs=1;
%for gibbs=1:REPS
while gibbs1<=fsize


 A0=chol(sigmaold,'lower');
trm1=beta2m*Qstar*A0';
trm2=beta2m*beta2m'+sigmam;
RR=[sigmaold trm1';[trm1 trm2]];
[Ystar,sig]=transformH1x(Y,RR,M);
 [bold,problemb]=drawvarnewx([Ystar;yd],[X;xd],sig,N,L,bold0,EX);
 bold0=bold;



varcoef=reshape(bold,N*L+EX,N);
resid=Y-X*varcoef;
T1=T+T0;
[sigmaold,naccept2x]=draw_sigma(M,iscale,T1,resid,Qstar,beta2m,sigmam,sigmaold);
naccept2=naccept2+naccept2x;

%draw Qstar
 qdraw=randn(N,1);
 qdraw=qdraw/norm(qdraw);
A0=chol(sigmaold,'lower');

 lpnew=loglik_m_given_y(M, resid, A0, qdraw, beta2m, sigmam.^0.5);
  lpold=loglik_m_given_y(M,resid, A0, Qold', beta2m, sigmam.^0.5);
  if isnan(lpnew) || isinf(lpnew) 
      lpnew=-inf;
  end
  
   if isnan(lpold) || isinf(lpold) 
      lpold=-inf;
   end


accept=exp(lpnew-lpold);
if accept>rand
      Qold=qdraw';
      naccept=naccept+1;
 end
Qstar=Qold;



epsilon=((Qstar / A0)*resid')';
cc=corrcoef([epsilon M]);
check=cc(1,2);%(A0t(:,:,1))'*Qstar';%Qstar(1)<0;%invpd(A0t(:,:,1))'*Qstar';
% check1=(A0t(:,:,1))'*Qstar';
ee=check(1)<0;
if ee
    Qstar=Qstar*-1;
    epsilon=epsilon*-1;
    Qold=Qold*-1;
end


%draw betam sigmam
%draw betam sigmam
 beta2m=getreg(M,epsilon(:,1),b0m,v0m,sigmam);
merrors=M-epsilon(:,1)*beta2m;
NU1=NU0+T;
S1=S0+merrors'*merrors;
ALPHA=NU1/2;
BETA=2/S1;
sigmam=1./gamrnd(ALPHA,BETA);



%draw missing data
if MISS
    dataid0=[Y M0];
    
[out,bt]=draw_data5_fixed(bold,A0,beta2m,sigmam,dataid0,mid,beta0d,P00d,N+1,N,NN,EX,L,Qstar);
M=out(:,1);
end





if rem(gibbs,1000)==0
fprintf('Iteration Number= %s \n', num2str([gibbs naccept/gibbs  naccept2/gibbs beta2m.^2/(sigmam+beta2m.^2)]));
end
% if rem(gibbs,100)==0
%     save('progress','hlast','amat','beta2m','sigmam','amat0','A0irf','ht0','m_t_true','a0irf')
% end

if gibbs>BURN
   
   if sum(gibbs==idx)>0

    bmat(gibbs1,:)=bold;
smat(gibbs1,:,:)=sigmaold;
bmatm(gibbs1,:)=beta2m;
smatm(gibbs1,:)=sigmam';
qsave(gibbs1,:)=Qstar;
esave(gibbs1,:)=epsilon';
%
    A0irf=(A0*Qstar')';
    A0x=zeros(N,N);
    A0x(1,:)=A0irf;
   shock=zeros(1,N);
   shock(1)=1;
   irf=irfsimx(reshape(bold,N*L+EX,N),N,L,A0x,shock,H+L,EX);
   irf1=irf./irf(1,1);
   
   %FEVD
   mse=0;
   for j=1:N
       shock=zeros(1,N);
       shock(j)=1;
     irfx=irfsimx(reshape(bold,N*L+EX,N),N,L,A0',shock,H+L,EX);
    mse=mse+cumsum(irfx.^2);
   end
   fv1=cumsum(irf.^2)./mse;



irfsave(gibbs1,:,:)=irf1;
fvsave(gibbs1,:,:)=fv1*100;

gibbs1=gibbs1+1;
   end
    end

  

gibbs=gibbs+1;
end
toc;

save('results_full','irfsave','fvsave','esave','bmatm','smatm')
