clear;
addpath('../functions')
sfolder='./results';
dfolder=('./data/');

load('priors1')
load('results1','bmat','smat','amatsave','a0irfsave')
parfor j=1:fsize
    beta2=squeeze(bmat(j,:,:));
    hlast=squeeze(smat(j,:,:));
    amat=squeeze(amatsave(j,:,:));
    A0irf=squeeze(a0irfsave(j,:,:));
    fvx=zeros(T,H,N);
for t=1:T
    A0=chofac(N,amat(t,:)')*(diag(hlast(t,:).^0.5));
    mse=0;
    for jj=1:N
    shck=zeros(1,N);
    shck(jj)=1;
   imp=irfsim(reshape(beta2(t,:),N*L+EX,N),N,L,A0',shck,H+L);
   mse=mse+cumsum(imp.^2);
    end
    A0x=zeros(N,N);
    A0x(1,:)=A0irf(t,:);
  shck=zeros(1,N);
    shck(1)=1;
   imp1=irfsim(reshape(beta2(t,:),N*L+EX,N),N,L,A0x,shck,H+L);
    mse1=cumsum(imp1.^2);
fvx(t,:,:)=mse1./mse;


end
j
irfsave(j,:,:,:)=fvx;
end

tmp=prctile(irfsave,[50 16 84]);

save('fevd','tmp')



TT=1962:0.25:2016.5;
HH=0:39;
TT=1958.75:0.25:2016.5;
d1 = datetime(1958,9,1,8,0,0);

d2 = datetime(2016,6,1,8,0,0);
dd = d1:calquarters(1):d2;
dd=datenum(dd);
figure(1)
subplot(3,3,1);
mesh(HH,TT,squeeze(tmp(1,:,:,1)))
axis tight
xlabel('Horizon');
ylabel('Years');
zlabel('T')
title('Median Response')

subplot(3,3,2)
plotx2(dd',(tmp(:,:,1,1))')
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
datetick('x','keepticks');
xlabel('Years')
title('Response at Horizon 0')
xlim([min(dd) max(dd)]);

subplot(3,3,3)
plotx2(dd',(tmp(:,:,8,1))')
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
datetick('x','keepticks');
xlabel('Years')
title('Response at Horizon 8')
xlim([min(dd) max(dd)]);

%%%%%%%%%%%%%%%%%%%%%

subplot(3,3,4);
mesh(HH,TT,squeeze(tmp(1,:,:,2)))
axis tight
xlabel('Horizon');
ylabel('Years');
zlabel('Y')

subplot(3,3,5)
plotx2(dd',(tmp(:,:,1,2))')
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,1,2))')) max(vec((tmp(:,:,1,2))'))]) 
datetick('x','keepticks');
xlabel('Years')
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,1,2))')) max(vec((tmp(:,:,1,2))'))]) 


subplot(3,3,6)
plotx2(dd',(tmp(:,:,8,2))')
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,8,2))')) max(vec((tmp(:,:,8,2))'))]) 
datetick('x','keepticks');
xlabel('Years')
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,8,2))')) max(vec((tmp(:,:,8,2))'))]) 

%%%%%%%%%%%%%%%%%%%%%%%%%
subplot(3,3,7);
mesh(HH,TT,squeeze(tmp(1,:,:,3)))
axis tight
xlabel('Horizon');
ylabel('Years');
zlabel('G')

subplot(3,3,8)
plotx2(dd',(tmp(:,:,1,3))')
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,1,3))')) max(vec((tmp(:,:,1,3))'))]) 
datetick('x','keepticks');
xlabel('Years')
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,1,3))')) max(vec((tmp(:,:,1,3))'))]) 


subplot(3,3,9)
plotx2(dd',(tmp(:,:,8,3))')
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,8,3))')) max(vec((tmp(:,:,8,3))'))]) 
datetick('x','keepticks');
xlabel('Years')
xlim([min(dd) max(dd)]);
ylim([min(vec((tmp(:,:,8,3))')) max(vec((tmp(:,:,8,3))'))]) 


