clear;
addpath('../../functions')

scale=xlsread('..\..\data\scaling.xls');

load('..\usa\fixed_coefficient\results_full');
load('..\usa\priors1')
load('..\usa\results1','irfsave','irfsave1')

TT=1958.75:0.25:2016.5;
HH=0:39;
d1 = datetime(1958,9,1,8,0,0);
d2 = datetime(2016,6,1,8,0,0);
dd = d1:calquarters(1):d2;
T1=datetime(1984,12,1,8,0,0);
e1=dd<=T1;
e2=e1==0;
dd=datenum(dd);


tmpx=prctile(irfsave1*100,[50 16 84]);
tmpf=prctile(fvsave,[50 16 84]);
figure(1)
subplot(2,3,1);
mesh(HH,TT,squeeze(tmpx(1,:,:,2)))
axis tight
xlabel('Horizon');
ylabel('Years');
zlabel('USA')
title('Contribution of the tax shock to the FEV of GDP')


subplot(2,3,2)
plotx2(dd',(tmpx(:,:,8,2))')
hold on
plot(dd',repmat(tmpf(1,8,2)',length(dd),1),':k','LineWidth',2);
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
datetick('x','keepticks');
xlabel('Years')
title('FEVD (2 years)')
xlim([min(dd) max(dd)]);


subplot(2,3,3)
plotx2(dd',(tmpx(:,:,20,2))')
hold on
plot(dd',repmat(tmpf(1,20,2)',length(dd),1),':k','LineWidth',2);
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
datetick('x','keepticks');
xlabel('Years')
title('FEVD (5 years)')
axis tight
xlim([min(dd) max(dd)]);




load('..\uk\fixedcoefficient\results_full');
load('..\uk\priors1')
load('..\uk\results1','irfsave','irfsave1')

TT=1965.5:0.25:2009.75;
HH=0:39;
d1 = datetime(1965,6,1,8,0,0);
d2 = datetime(2009,9,1,8,0,0);
dd = d1:calquarters(1):d2;
T1=datetime(1984,12,1,8,0,0);
e1=dd<=T1;
e2=e1==0;
dd=datenum(dd);


tmpx=prctile(irfsave1*100,[50 16 84]);
tmpf=prctile(fvsave,[50 16 84]);
subplot(2,3,4);
mesh(HH,TT,squeeze(tmpx(1,:,:,2)))
axis tight
xlabel('Horizon');
ylabel('Years');
zlabel('UK')


subplot(2,3,5)
plotx2(dd',(tmpx(:,:,8,2))')
hold on
plot(dd',repmat(tmpf(1,8,2)',length(dd),1),':k','LineWidth',2);
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
datetick('x','keepticks');
xlabel('Years')
xlim([min(dd) max(dd)]);


subplot(2,3,6)
plotx2(dd',(tmpx(:,:,20,2))')
hold on
plot(dd',repmat(tmpf(1,20,2)',length(dd),1),':k','LineWidth',2);
NumTicks = 10;
L = get(gca,'XLim');
set(gca,'XTick',linspace(L(1),L(2),NumTicks))
recessionplot
datetick('x','keepticks');
xlabel('Years')
axis tight
xlim([min(dd) max(dd)]);
