function algorithm_4_updated(file)
addpath('../../functions')
sfolder='./results';
dfolder=('data/');


fname=strcat(dfolder,'datax',num2str(file),'.mat');
load(fname,'data0','beta2x0','amat0','irfx0','m_t','m_t_true','sigmat0','irfx01','ht0','a0irf');

mid=isnan(m_t);  %id for missing obs in instrument
tmp=m_t;
for j=1:cols(tmp)
tmp(mid(:,j),j)=0;
end
out=fillmissing(m_t,'nearest');
data=data0;
REPS=10000;
BURN=5000;
SKIP=2;

k=cols(m_t);
H=40;
CHECK=1;
maxdraws=1000;
EX=1;
idx=BURN+1:SKIP:REPS;
fsize=length(idx);
N=cols(data);
npart=10;

L=1;
Y=data;
X=prepare(data,L);
Y=Y(L+1:end,1:N);
X=X(L+1:end,:);
if any(sum(mid))>0
M=out(L+1:end,:); %intrument 
M0=tmp(L+1:end,:); %instrument withmiss=0
else
    M=m_t(L+1:end,:);
end

%setting priors and starting values
T0=20;
y0=Y(1:T0,:);
x0=X(1:T0,:);
b0=x0\y0;
e0=y0-x0*b0;
sigma0=(e0'*e0)/T0;
V0=kron(sigma0,invpd(x0'*x0));
%priors for the variance of the transition equation
Q0=V0*T0*3.5e-03;  %prior for the variance of the transition equation error
P00=V0;                    % variance of the intial state vector  variance of state variable p[t-1/t-1]
beta0=vec(b0)';       % intial state vector   %state variable  b[t-1/t-1]
Q=Q0;

%priors and starting values for aij
C0=chol(sigma0);
C0=C0./repmat(diag(C0),1,N);
C0=inv(C0)';
PC0=10;
amatx=zeros(1,N*(N-1)/2);
D0=zeros(N*(N-1)/2,N*(N-1)/2);
j=1;
for i=1:N-1
    temp=C0(i+1,1:i);
amatx(1,j:j+cols(temp)-1)=temp;
D0(j:j+cols(temp)-1,j:j+cols(temp)-1)=eye(cols(temp))*(10^(-1));
j=j+cols(temp);
end
DD=D0;

%priors for instrument equation
b0m=ones(k,1).*1;
v0m=ones(k,1).*10;  %prior variance
meanv=ones(k,1).*1; %prior mean for sig
variancev=ones(k,1).*10;%prior variance
S0=2.*meanv.*(1+(meanv.^2)./(variancev.^2));
NU0=2.*(2+(meanv.^2)./(variancev.^2));
beta2m=b0m;
sigmam=meanv;
%remove intial Sample
Y=Y(T0+1:end,:);
X=X(T0+1:end,:);
M=M(T0+1:end,:);
mid=mid(T0+L+1:end,:);
if any(sum(mid))>0
M0=M0(T0+1:end,:);
end
T=rows(X);
amat00=repmat(amatx,T,1);
beta20=repmat(beta0,T,1);
%priors for the initial condition of the stochastic volatility
SS0=10;
g0=0.01^2;  %prior scale parameter for inverse gamma
Tg0=1;     %prior degrees of freedom
g=ones(1,N).*g0;
MU0=log(diag(sigma0));
hlast=(diff(Y).^2)+0.0001;   %rough guess for stochastic volatility 
hlast=[hlast(1:2,:);hlast];  %rough intial guess for svol

e0=Y-X*(X\Y) ;
epsilon=e0*C0; %starting values for orthogonolised resids
%50 iterations to smooth initial estimates of stochastic volatility

for m=1:50
  hnew=zeros(T+1,N);
  for i=1:N
      htemp=getsvolx(hlast(:,i),g0,MU0(i),SS0,epsilon(:,i));
      hnew(:,i)=htemp;
      
  end
hlast=hnew;
[beta2,error,roots,epsilon,problem]=...
          carterkohnvar(Y,X,Q,amat00,hlast,ones(T,1),beta0,P00,L,0,maxdraws,EX);
 j=1;
for i=2:N
    ytemp=error(:,i);
    xtemp=error(:,1:i-1)*-1;
    ytemp=(ytemp)./sqrt(hlast(2:rows(hlast),i));
    xtemp=(xtemp)./repmat(sqrt(hlast(2:rows(hlast),i)),1,cols(xtemp));
    a0=C0(i,1:i-1);
    pa=PC0*diag(abs(a0));
    Qa=DD(j:j+cols(xtemp)-1,j:j+cols(xtemp)-1);
    [a1,trash]=carterkohn1(a0,pa,ones(T+1,1),Qa,ytemp,xtemp);
    amat00(:,j:j+cols(a1)-1)=a1;
    j=j+cols(a1);
end     
      
      
      
end
amatinv=zeros(T,cols(amat00));
for t=1:T
    tmp=chofac(N,amat00(t,:)');
    tmp1=inv(tmp);
    amatinv(t,:)=unchofac(tmp1)';
end
hlast=hlast(2:end,:);
xfixa=[amatinv log(hlast)]; %initial states: A_t and H_t
beta0a=xfixa(1,:);
BETA01=beta0a;
NS1=cols(BETA01);

tmp=randn(N,N);

[Qold,~]=qr(tmp);
Qstar=Qold;



NN=length(beta0);
NNx=cols(amat00);

if any(sum(mid))>0
    MISS=1;
else
    MISS=0;
end

if MISS
    %Initial values for the Kalman filter B0/0 when drawing missing data
    %Initial values for the Kalman filter B0/0 when drawing missing data
beta0d=[];
for j=0:L-1
    beta0d=[beta0d [Y(L-j,:) M(L-j,:)]];
end
P00d=eye(cols(beta0d));  %P[0/0]
end




% save(strcat(sfolder,filesep,'priors1'))
%storage
bmat=zeros(fsize,T,NN);
smat=zeros(fsize,T,N);
amatsave=zeros(fsize,T,(N*(N-1))/2);
gmat=zeros(fsize,N);
qa=zeros(fsize,(N*(N-1))/2,(N*(N-1))/2);
qq=zeros(fsize,NN,NN);
bmatm=zeros(fsize,k);
smatm=zeros(fsize,k);
qsave=zeros(fsize,N);
irfsave=zeros(fsize,T,H,N);
irfsave1=zeros(fsize,T,H,N);

datasave=zeros(fsize,T,k);

naccept=0;

tic;
gibbs2=1;
gibbs1=1;
gibbs=1;
Q=Q0;
%for gibbs=1:REPS
while gibbs1<=fsize

%step 1: draw beta amat H using the particle gibbs sampler
Fmat=eye(NS1);
Mu=zeros(1,NS1);
Qbig=blkdiag(DD,diag(g));
bm=zeros(k,N);
bm(:,1)=beta2m;
sm=diag(sigmam);
[betax,BB,W,problem]=...
   pftest200Fr(Fmat,Mu,Qbig,xfixa,Y,X,M,bm,sm,beta2,Qstar,NS1,BETA01,npart,N,L,EX);
index=discretesample(W(:,end),1);
xfixa=betax(:,:,index);
amat=xfixa(:,1:NNx);
hlast=exp(xfixa(:,NNx+1:end));
A0t=zeros(N,N,T);
for t=1:T
    A0=chofac(N,amat(t,:)')*(diag(hlast(t,:).^0.5));
    A0t(:,:,t)=A0;
end

%DRAW TVP parameters VAR


[beta2,error,roots,problemb]=...
carterkohnvar4(Y,X,Q,A0t,beta0,P00,L,CHECK,maxdraws,EX,M,bm,sm,Qstar);
if problemb
    beta2=beta20;
else
    beta20=beta2;
end


%draw Qstar
 tmp=randn(N,N);
 [qdraw,~]=qr(tmp);
lpnew=0;
lpold=0;
%check=0;
for t=1:T
 A0=A0t(:,:,t);
 lpnewi=loglik_m_given_y2(M(t,:), error(t,:), A0, qdraw, bm, sm);
  lpoldi=loglik_m_given_y2(M(t,:), error(t,:), A0, Qold, bm, sm);
  if isnan(lpnewi) || isinf(lpnewi) 
      lpnewi=-100;
  end
  
   if isnan(lpoldi) || isinf(lpoldi) 
      lpoldi=-100;
   end
  lpnew=lpnew+lpnewi;
  lpold=lpold+lpoldi;
end

accept=exp(lpnew-lpold);
if accept>rand
      Qold=qdraw;
      naccept=naccept+1;
 end
Qstar=Qold;






epsilon=zeros(T,1);
A0irf=zeros(T,N);
for t=1:T
    A0=A0t(:,:,t);
    tmp=(Qstar' / A0)*error(t,:)';
    epsilon(t,:)=tmp(1);
    tmp=(A0*Qstar)';
    A0irf(t,:)=tmp(1,:);
end


ee=zeros(k,1);
for j=1:k
cc=corrcoef([epsilon M(:,j)]);
check=cc(1,2);%
%normalise sign of epsilon
ee(j)=check(1)<0;
if ee(j)
    Qstar(:,j)=Qstar(:,j)*-1;
    Qold(:,j)=Qold(:,j)*-1;
    
end
end
if any(ee)
    epsilon=-epsilon;
end



%draw betam sigmam
for j=1:k
 beta2m(j)=getreg(M(:,j),epsilon(:,1),b0m(j),v0m(j),sigmam(j));
 merrors=M(:,j)-epsilon(:,1)*beta2m(j);
NU1=NU0(j)+T;
S1=S0(j)+merrors'*merrors;
ALPHA=NU1/2;
BETA=2/S1;
sigmam(j)=1./gamrnd(ALPHA,BETA);
end

bm=zeros(k,N);
bm(:,1)=beta2m;
sm=diag(sigmam);


%step 3: Draw DD
errord=diff(amat);
scaled=(errord'*errord)+D0;
DD=iwpq(T+NNx+1,invpd(scaled));


%step 4: Draw G
g=zeros(1,N);
for i=1:N
     gerrors=diff(log(hlast(:,i)));
     g(i)=ig(gerrors,Tg0,g0);  %draw from the inverse Gamma distribution
end




% step 2 sample Q from the IW distribution
errorq=diff(beta2);
scaleQ=(errorq'*errorq)+Q0;
Q=iwpq(T+T0,invpd(scaleQ));

%draw missing data
if MISS
    dataid0=[Y M0];
    
[out,bt]=draw_data6(beta2,A0t,bm,sm,dataid0,mid,beta0d,P00d,N+k,N,NN,EX,L,Qstar);
M=out(:,1:k);
end









fprintf('Iteration Number= %s \n', num2str([gibbs naccept/gibbs  file]));

% if rem(gibbs,100)==0
%     save('progress','hlast','amat','beta2m','sigmam','amat0','A0irf','ht0','m_t_true','a0irf')
% end

if gibbs>BURN
   
   if sum(gibbs==idx)>0

    bmat(gibbs1,:,:)=beta2;
smat(gibbs1,:,:)=hlast;
amatsave(gibbs1,:,:)=amat;
qa(gibbs1,:,:)=DD;
gmat(gibbs1,:)=g;
qq(gibbs1,:,:)=Q;
bmatm(gibbs1,:)=beta2m;
smatm(gibbs1,:)=sigmam';
qsave(gibbs1,:)=Qstar(:,1)';
if MISS
    datasave(gibbs1,:,:)=M;
end
%irf
%irf
irfx=zeros(T,H,N);
irfx1=irfx;
for t=1:T
    A0=A0t(:,:,t);
    A0x=(A0*Qstar)';
   imp=irfsim(reshape(beta2(t,:),N*L+EX,N),N,L,A0x,[1 0 0 ],H+L);
irfx1(t,:,:)=imp;
irfx(t,:,:)=imp./imp(1,1);


end



irfsave(gibbs1,:,:,:)=irfx;
irfsave1(gibbs1,:,:,:)=irfx1;

gibbs1=gibbs1+1;
   end
    end

  

gibbs=gibbs+1;
end
toc;
% save(strcat(sfolder,'/results',num2str(file)),'bmat','amat','amatsave','qa','gmat','qq','smat','irfsave');

irfm=squeeze(median(irfsave1));%not normalised
irfx=squeeze(median(irfsave));
save(strcat(sfolder,'/results',num2str(file)),'irfm','irfx');




