clear
beep off;
addpath('../functions');
dfolder='./data/';
sfolder='./results/';
clc
rng(5) %katerina changed this, to get the previous results set rng(1)
maxfile=372; 
HORZ=20;
tic;
%inputs

REPS=100; %REPS datasets
MISS=0; %If MISS=1, NANs inserted in instrument
Tx=200;
Nfact=2;
NN=100;
N=3;
L=1;
TT0=100;
T0=20;
T=Tx+T0+TT0; %time series with Tx initial conditions T0=training sample
fload=randn(NN,Nfact);
rmat=rand(NN,1);

Q=eye(N*(N*L+1)).*0.0001;  %for TVP coefficients
QA=eye(3).*0.01;  %for TVP contemporaneous impact matrix
g=eye(3).*0.01;
betam=0.2;
sigmav=0.1;
q1=randn(N,1);
q1=q1/norm(q1);
% if q1(1)<0
%     q1=q1*-1;
% end
 %generate state variables
    At=zeros(T,3);
    Ht=zeros(T,3);
    Ht(1,:)=[0.002 0.002 0.002];
    At(1,:)=[-0.01 0.03 -0.01]; 
    SIGMAT=zeros(N,N,T);
    A0t=zeros(N,N,T);
    for t=2:T
        chck=-1;
        while chck<0
        At(t,:)=At(t-1,:)+randn(1,3)*chol(QA);
        Ht(t,:)=Ht(t-1,:)+randn(1,3)*chol(g);
        A0=[[1 At(t,1:2)]' [0 1 At(t,3)]' [0 0 1]'];
        ee1=rcond(A0)<1e-14;
        if ee1==0
            chck=1;
        end
        end
      SIGMAT(:,:,t)=A0*diag(exp(Ht(t,:)))*A0';  
      A0t(:,:,t)=A0*diag(exp(Ht(t,:)).^0.5);
    end
    
    beta=zeros(T,N*(N*L+1));
    beta(1,:)=[0.2 -0.1  0.1 -0.01 0.1 0.2 -0.2 -0.01 0.2 -0.1 0.2 -0.005];
    for t=2:T
        chck=-1;
        while chck<0
            tmp=beta(t-1,:)+randn(1,N*(N*L+1))*chol(Q);
            ee=stability(tmp,N,1,1);
            if ee==0
                chck=1;
            end
        end
        beta(t,:)=tmp;
    end
for M=1:REPS

   

H=blkdiag(eye(1),fload);
ymat=zeros(T,N);
xhat=zeros(T,NN+1);
ehat=zeros(T,NN);
epsilon=zeros(T,N+1);
m_t=zeros(T,1);
for t=2:T

A0=A0t(:,:,t);
sigma=A0*A0';
trm1=betam*q1'*A0';
trm2=betam*betam'+sigmav;
covmat=[sigma trm1';[trm1 trm2]];
epsilon(t,:)=randn(1,4);

resid=mvnrnd(zeros(1,N+1),covmat,1);%epsilon(t,:)*abig';
m_t(t,:)=resid(end);
xmat=[ymat(t-1,:)  1];
ymat(t,:)=xmat*reshape(beta(t,:)',N*L+1,N)+resid(1:N);
ehat(t,:)=randn(1,NN).*sqrt(rmat');
xhat(t,:)=ymat(t,:)*H'+[ 0 ehat(t,:)];


    A0irf(t,:)=(A0*q1)';
    A0x=zeros(N,N);
    A0x(1,:)=A0irf(t,:);
tmp=irfsim(reshape(beta(t,:),N*L+1,N),N,1,A0x,[1 0 0 ],41);
irfx=tmp*H';

irfx1(t,:,:)=irfx;    




end

data0=xhat(TT0+1:end,2:end);
Z=xhat(TT0+1:end,1);
beta2x0=beta(TT0+1:end,:);
amat0=At(TT0+1:end,:);
ht0=Ht(TT0+1:end,:);
irfx0=irfx1(TT0+1:end,:,:);
irfx0_c=cumsum(irfx0,2);
a0irf=A0irf(TT0+1:end,:);
m_t=m_t(TT0+1:end,:);
sigmat0=SIGMAT(:,:,TT0+1:end);
m_t_true=m_t;
if MISS
    m_t(1:100,1)=nan(100,1);
end
fname=strcat(dfolder,'datax',num2str(M),'.mat');
save(fname,'data0','beta2x0','amat0','irfx0','m_t','m_t_true','sigmat0','ht0','a0irf','Z','irfx0_c');
end


