function run_favar(file)
addpath('../../functions')
sfolder='./results';
dfolder=('./data/');


fname=strcat(dfolder,'datax',num2str(file),'.mat');
load(fname,'data0','beta2x0','amat0','irfx0','m_t','m_t_true','sigmat0','ht0','a0irf','Z');
%prepare data
%standardise the data
dataF=standardise([Z data0]);%[data0 Z];%
%dataF=demean([data0 Z]);%[data0 Z];%

[betamat,cmat]=getbeta(dataF,[Z data0]);%scaling factors to convert IRFs into original data units
Z=dataF(:,1);
dataF=dataF(:,2:end);

%get an intial guess for the factor via principal components
Nfact=2;
pmat=extract(dataF,Nfact);


mid=isnan(m_t(:,1));  %id for missing obs in instrument
tmp=m_t(:,1);
tmp(mid)=0;
datax=[Z pmat tmp ];
if sum(mid)>0 %initial estimate for missing instrument data via Kalman filter
    [out,out1]=draw_data_initial1(datax,mid,zeros(1,cols(datax)),eye(cols(datax)),cols(datax),cols(datax)-1,1,0.1);
end
REPS=10000;
BURN=5000;
SKIP=10;

  k=1;
    Horz=40;
CHECK=1;
maxdraws=1000;
EX=1;
idx=BURN+1:SKIP:REPS;
fsize=length(idx);
MM=cols(dataF);% size of the panel
Ny=cols(Z);
N=Nfact+Ny;
npart=10;

L=1;
Y=[Z pmat];
X=prepare(Y,L);
Y=Y(L+1:end,1:N);
X=X(L+1:end,:);
if sum(mid)>0
M=out(L+1:end,1); %intrument 
M0=tmp(L+1:end,:); %instrument withmiss=0
else
    M=m_t(L+1:end,:);
end

%setting priors and starting values
T0=20;
y0=Y(1:T0,:);
x0=X(1:T0,:);
b0=x0\y0;
e0=y0-x0*b0;
sigma0=(e0'*e0)/T0;
V0=kron(sigma0,invpd(x0'*x0));
%priors for the variance of the transition equation
Q0=V0*T0*3.5e-03;  %prior for the variance of the transition equation error
P00=V0;                    % variance of the intial state vector  variance of state variable p[t-1/t-1]
beta0=vec(b0)';       % intial state vector   %state variable  b[t-1/t-1]
Q=Q0;

%priors and starting values for aij
C0=chol(sigma0);
C0=C0./repmat(diag(C0),1,N);
C0=inv(C0)';
PC0=10;
amatx=zeros(1,N*(N-1)/2);
D0=zeros(N*(N-1)/2,N*(N-1)/2);
j=1;
for i=1:N-1
    temp=C0(i+1,1:i);
amatx(1,j:j+cols(temp)-1)=temp;
D0(j:j+cols(temp)-1,j:j+cols(temp)-1)=eye(cols(temp))*(10^(-1));
j=j+cols(temp);
end
DD=D0;

%priors for instrument equation
b0m=1;
v0m=0.5;
d0m=0.1;
td0m=5;
beta2m=b0m;
sigmam=d0m;
%remove intial Sample
Y=Y(T0+1:end,:);
X=X(T0+1:end,:);
M=M(T0+1:end,:);
dataF=dataF(T0+L+1:end,:);
pmat=pmat(T0+L+1:end,:);
Z=Z(T0+L+1:end,:);
mid=mid(T0+L+1:end,:);
if sum(mid)>0
M0=M0(T0+1:end,:);
end
T=rows(X);
amat00=repmat(amatx,T,1);
beta20=repmat(beta0,T,1);
%priors for the initial condition of the stochastic volatility
SS0=10;
g0=0.01^2;  %prior scale parameter for inverse gamma
Tg0=1;     %prior degrees of freedom
g=ones(1,N).*g0;
MU0=log(diag(sigma0));
hlast=(diff(Y).^2)+0.0001;   %rough guess for stochastic volatility 
hlast=[hlast(1:2,:);hlast];  %rough intial guess for svol

e0=Y-X*(X\Y) ;
epsilon=e0*C0; %starting values for orthogonolised resids
%50 iterations to smooth initial estimates of stochastic volatility

for m=1:50
  hnew=zeros(T+1,N);
  for i=1:N
      htemp=getsvolx(hlast(:,i),g0,MU0(i),SS0,epsilon(:,i));
      hnew(:,i)=htemp;
      
  end
hlast=hnew;
[beta2,error,roots,epsilon,problem]=...
          carterkohnvar(Y,X,Q,amat00,hlast,ones(T,1),beta0,P00,L,0,maxdraws,EX);
 j=1;
for i=2:N
    ytemp=error(:,i);
    xtemp=error(:,1:i-1)*-1;
    ytemp=(ytemp)./sqrt(hlast(2:rows(hlast),i));
    xtemp=(xtemp)./repmat(sqrt(hlast(2:rows(hlast),i)),1,cols(xtemp));
    a0=C0(i,1:i-1);
    pa=PC0*diag(abs(a0));
    Qa=DD(j:j+cols(xtemp)-1,j:j+cols(xtemp)-1);
    [a1,trash]=carterkohn1(a0,pa,ones(T+1,1),Qa,ytemp,xtemp);
    amat00(:,j:j+cols(a1)-1)=a1;
    j=j+cols(a1);
end     
      
      
      
end
amatinv=zeros(T,cols(amat00));
for t=1:T
    tmp=chofac(N,amat00(t,:)');
    tmp1=inv(tmp);
    amatinv(t,:)=unchofac(tmp1)';
end
hlast=hlast(2:end,:);
xfixa=[amatinv log(hlast)]; %initial states: A_t and H_t
beta0a=xfixa(1,:);
BETA01=beta0a;
NS1=cols(BETA01);
tmp=randn(N,1);
tmp=tmp/norm(tmp);

Qold=tmp';
Qstar=Qold;

%priors and starting values for observation equation
pmat0=[Z(L+1,:) pmat(L+1,:)];  %state vector S[t-1/t-1]
for i=1:L-1
    pmat0=[pmat0 [Z(L+1-i,:) pmat(L+1-i,:)]];
end
NS=cols(pmat0);
P00x=eye(NS);  %P[t-1/t-1]
rmatin=ones(MM,1); %arbitrary starting value for the variance of the idiosyncratic component

%prior for the factor loadings,variances and VAR
fload0=(pmat\dataF);
vfload0=eye(Nfact)*10;
vg=0.00001;
tg=1;

NN=length(beta0);
NNx=cols(amat00);

if sum(mid)>0
    MISS=1;
else
    MISS=0;
end

if MISS
    %Initial values for the Kalman filter B0/0 when drawing missing data
    %Initial values for the Kalman filter B0/0 when drawing missing data
beta0d=[];
for j=0:L-1
    beta0d=[beta0d [Y(L-j,:) M(L-j,:)]];
end
P00d=eye(cols(beta0d));  %P[0/0]
end




% save(strcat(sfolder,filesep,'priors1'))
%storage
bmat=zeros(fsize,T,NN);
smat=zeros(fsize,T,N);
amatsave=zeros(fsize,T,(N*(N-1))/2);
gmat=zeros(fsize,N);
qa=zeros(fsize,(N*(N-1))/2,(N*(N-1))/2);
qq=zeros(fsize,NN,NN);
bmatm=zeros(fsize,1);
smatm=zeros(fsize,1);
qsave=zeros(fsize,N);
irfsave=zeros(fsize,T,Horz,MM+1);

datasave=zeros(fsize,T,1);

naccept=0;

tic;
gibbs2=1;
gibbs1=1;
gibbs=1;
Q=Q0;
%for gibbs=1:REPS
while gibbs1<=fsize

%step 1: draw beta amat H using the particle gibbs sampler
Fmat=eye(NS1);
Mu=zeros(1,NS1);
Qbig=blkdiag(DD,diag(g));

[betax,BB,W,problem]=...
   pftest100Fr(Fmat,Mu,Qbig,xfixa,Y,X,M,beta2m,sigmam,beta2,repmat(Qstar,T,1),NS1,BETA01,npart,N,L,EX);
index=discretesample(W(:,end),1);
xfixa=betax(:,:,index);
amat=xfixa(:,1:NNx);
hlast=exp(xfixa(:,NNx+1:end));
A0t=zeros(N,N,T);
for t=1:T
    A0=chofac(N,amat(t,:)')*(diag(hlast(t,:).^0.5));
    A0t(:,:,t)=A0;
end

%DRAW TVP parameters VAR


[beta2,error,roots,problemb]=...
carterkohnvar3(Y,X,Q,A0t,beta0,P00,L,CHECK,maxdraws,EX,M,beta2m,sigmam,Qstar);
if problemb
    beta2=beta20;
else
    beta20=beta2;
end


%draw Qstar
 qdraw=randn(N,1);
 qdraw=qdraw/norm(qdraw);
lpnew=0;
lpold=0;
%check=0;
for t=1:T
 A0=A0t(:,:,t);
 lpnewi=loglik_m_given_y(M(t,:), error(t,:), A0, qdraw, beta2m, sigmam.^0.5);
  lpoldi=loglik_m_given_y(M(t,:), error(t,:), A0, Qold', beta2m, sigmam.^0.5);
  if isnan(lpnewi) || isinf(lpnewi) 
      lpnewi=-100;
  end
  
   if isnan(lpoldi) || isinf(lpoldi) 
      lpoldi=-100;
   end
  lpnew=lpnew+lpnewi;
  lpold=lpold+lpoldi;
end

accept=exp(lpnew-lpold);
if accept>rand
      Qold=qdraw';
      naccept=naccept+1;
 end
Qstar=Qold;


epsilon=zeros(T,1);
A0irf=zeros(T,N);
for t=1:T
    A0=A0t(:,:,t);
    epsilon(t,:)=(Qstar / A0)*error(t,:)';
    A0irf(t,:)=(A0*Qstar')';
end
cc=corrcoef([epsilon M]);
check=cc(1,2);%(A0t(:,:,1))'*Qstar';%Qstar(1)<0;%invpd(A0t(:,:,1))'*Qstar';
% check1=(A0t(:,:,1))'*Qstar';
ee=check(1)<0;
if ee
    Qstar=Qstar*-1;
    epsilon=epsilon*-1;
    Qold=Qold*-1;
end


%draw betam sigmam
 beta2m=getreg(M,epsilon(:,1),b0m,v0m,sigmam);

 merrors=M-epsilon(:,1)*beta2m;
 sigmam=ig(merrors,td0m,d0m);


%step 3: Draw DD
errord=diff(amat);
scaled=(errord'*errord)+D0;
DD=iwpq(T+NNx+1,invpd(scaled));


%step 4: Draw G
g=zeros(1,N);
for i=1:N
     gerrors=diff(log(hlast(:,i)));
     g(i)=ig(gerrors,Tg0,g0);  %draw from the inverse Gamma distribution
end




% step 2 sample Q from the IW distribution
errorq=diff(beta2);
scaleQ=(errorq'*errorq)+Q0;
Q=iwpq(T+T0,invpd(scaleQ));

%draw missing data
if MISS
    dataid0=[Y M0];
    
[out,bt]=draw_data5(beta2,A0t,beta2m,sigmam,dataid0,mid,beta0d,P00d,N+1,N,NN,EX,L,Qstar);
M=out(:,1);
end


%%%Observation equation
[fload,rmat]=...
    getobseqparameters(dataF,pmat,...
    fload0,vfload0,vg,tg,rmatin);
rmatin=rmat;

%prepare matrices for the state space
%Y=H*factors+e
%factors=MU+F*Factors(-1)+v
%e~N(0,R)
%v~N(0,Q)

%matrix of factor loadings

H=zeros(MM+Ny,N*(L));
H(:,1:N)=blkdiag(eye(Ny),fload);



%matrix R
R=diag([zeros(Ny,1);rmat]);


[pmat,btx]=getfactorRho1_F(dataF,Z,T,NS,H,R,beta2,A0t,M,beta2m,sigmam,Qstar,N,L,EX,pmat0,P00x);

%update data
Y=[Z pmat];
Y=[repmat(Y(1,:),L,1);Y];
X=prepare(Y,L);
Y=Y(L+1:end,:);
X=X(L+1:end,:);







disp(sprintf('Iteration Number= %s ', num2str([gibbs naccept/gibbs beta2m sigmam file])));

% if rem(gibbs,100)==0
%     save('progress','hlast','amat','beta2m','sigmam','amat0','A0irf','ht0','m_t_true','a0irf')
% end

if gibbs>BURN
   
   if sum(gibbs==idx)>0

    bmat(gibbs1,:,:)=beta2;
smat(gibbs1,:,:)=hlast;
amatsave(gibbs1,:,:)=amat;
qa(gibbs1,:,:)=DD;
gmat(gibbs1,:)=g;
qq(gibbs1,:,:)=Q;
bmatm(gibbs1,:)=beta2m;
smatm(gibbs1,:)=sigmam';
qsave(gibbs1,:)=Qstar;
if MISS
    datasave(gibbs1,:)=M;
end
%irf
%irf
irfx1=zeros(T,Horz,MM+1);
for t=1:T
    A0=A0t(:,:,t);
    A0irf(t,:)=(A0*Qstar')';
    A0x=zeros(N,N);
    A0x(1,:)=A0irf(t,:);
   imp=irfsim(reshape(beta2(t,:),N*L+EX,N),N,L,A0x,[1 0 0 ],Horz+L);
   irf=(imp*H(:,1:N)'.*repmat([betamat'],Horz,1));
 
irfx1(t,:,:)=irf;


end



irfsave(gibbs1,:,:,:)=irfx1;

gibbs1=gibbs1+1;
   end
    end

  

gibbs=gibbs+1;
end
toc;
% save(strcat(sfolder,'/results',num2str(file)),'bmat','amat','amatsave','qa','gmat','qq','smat','irfsave');

irfm=squeeze(median(irfsave));%not normalised
irfm_c=cumsum(irfm,2);
save(strcat(sfolder,'/results',num2str(file)),'irfm','irfm_c');