function [beta2,temp,beta_tt] = KF( Y,X,sigma,bdraw,beta0,P00 )
ns=cols(beta0);
T=rows(Y);
F=eye(ns);
mu=0;
beta_tt=[];          %will hold the filtered state variable
ptt=zeros(T,ns,ns);    % will hold its variance
beta11=beta0;
p11=P00;
Q=0;


% %%%%%%%%%%%Step 2b run Kalman Filter

for i=1:T
   x=[X(i,:);X(i,:)];
A=[1 0;1 1/bdraw(i,:)];
R=A*sigma*A';

    %Prediction
beta10=mu+beta11*F';
p10=F*p11*F'+Q;
yhat=(x*(beta10)')';                                               
eta=Y(i,:)-yhat;
feta=(x*p10*x')+R;
%updating

K=(p10*x')*invpd(feta);
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);

ptt(i,:,:)=p11;
beta_tt=[beta_tt;beta11];

end


%%%%%%%%%%%end of Kalman Filter%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%step 2c Backward recursion to calculate the mean and variance of the distribution of the state
%vector

beta2 = zeros(1,ns);   %this will hold the draw of the state variable
wa=randn(1,ns);



i=T;  %period t
p00=squeeze(ptt(i,:,:)); 
beta2(1,:)=beta_tt(i:i,:)+(wa(1,:)*chol(p00));   %draw for beta in period t from N(beta_tt,ptt)
temp=beta_tt(i:i,:);

