function[beta2]=carterkohnUC(Y,beta0,P00,hlast,hlastq)
T=rows(Y);
N=cols(Y);
%%Step 2a Set up matrices for the Kalman Filter

ns=cols(beta0);
hmat=1;
F=1;
mu=0;
beta_tt=zeros(T,ns);          %will hold the filtered state variable
ptt=zeros(T,ns,ns);    % will hold its variance
beta11=beta0;
p11=P00;


% %%%%%%%%%%%Step 2b run Kalman Filter

for i=1:T
   x=hmat;


R=hlast(i+1);
Q=hlastq(i+1);
    %Prediction
beta10=mu+beta11*F';
p10=F*p11*F'+Q;
yhat=(x*(beta10)')';                                               
eta=Y(i,:)-yhat;
feta=(x*p10*x')+R;
%updating
K=(p10*x')*invpd(feta);
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);

ptt(i,:,:)=p11;
beta_tt(i,:)=beta11;

end


%%%%%%%%%%%end of Kalman Filter%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%step 2c Backward recursion to calculate the mean and variance of the distribution of the state
%vector

jv=1;
fsmall=F(jv,:);
beta2 = zeros(T,ns);   %this will hold the draw of the state variable
wa=randn(T,ns);


i=T;  %period t
p00=squeeze(ptt(i,jv,jv)); 
beta2(i,:)=beta_tt(i:i,jv)+(wa(i:i,jv)*cholx(p00));   %draw for beta in period t from N(beta_tt,ptt)

%periods t-1..to .1

for i=T-1:-1:1
pt=squeeze(ptt(i,:,:));
Q=hlastq(i+2,:);

iFptF=invpd(fsmall*pt*fsmall'+Q(jv,jv));
bm=beta_tt(i:i,:)+(pt*fsmall'*iFptF*(beta2(i+1:i+1,jv)-mu(jv)'-beta_tt(i,:)*fsmall')')';  %update the filtered beta for information contained in beta[t+1]                                                                                 %i.e. beta2(i+1:i+1,:) eq 8.16 pp193 in Kim Nelson
pm=pt-pt*fsmall'*iFptF*fsmall*pt;  %update covariance of beta
beta2(i:i,:)=bm+(wa(i:i,jv)*cholx(pm(jv,jv)));  %draw for beta in period t from N(bm,pm)eq 8.17 pp193 in Kim Nelson
end
