function[beta2,error,roots,problem,beta_tt]=...
carterkohnvar2_svol(Y,X,Q,at,beta0,P00,L,CHECK,maxdraws,EX,M,beta2m,sigmam,q1)
T=rows(Y);
N=cols(Y);
%%Step 2a Set up matrices for the Kalman Filter

ns=cols(beta0);
beta0=zeros(1,ns);
NN=(N*L+EX)*N;
F=eye(ns,ns);
mu=zeros(1,ns);
beta_tt=zeros(T,ns);          %will hold the filtered state variable
ptt=zeros(T,ns,ns);    % will hold its variance
beta11=beta0;
p11=P00;


% %%%%%%%%%%%Step 2b run Kalman Filter

for i=1:T
   x=kron(eye(N),X(i,:));
   x=[x;zeros(1,cols(x))];
  


A0=at(:,:,i);
sigma=A0*A0';
trm1=beta2m*q1*A0';
trm2=beta2m*beta2m'+sigmam(i,:);
covmat=[sigma trm1';[trm1 trm2]];
Rx=covmat;
R=eye(N+1,N+1);
R(1:N+1,1:N+1)=Rx;
    %Prediction
beta10=mu+beta11*F';
p10=F*p11*F'+Q;
yhat=(x*(beta10)')';                                              
eta=[Y(i,:) M(i,:)]-yhat;
feta=(x*p10*x')+R;
%updating
K=(p10*x')*invpd(feta);
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);

ptt(i,:,:)=p11;
beta_tt(i,:)=beta11;

end


%%%%%%%%%%%end of Kalman Filter%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%step 2c Backward recursion to calculate the mean and variance of the distribution of the state
%vector
chck=-1;
problem=0;
trys=1;
while chck<0 && trys<=maxdraws
    
beta2 = zeros(T,ns);   %this will hold the draw of the state variable
wa=randn(T,ns);
error=zeros(T,N);
roots=zeros(T,1);

i=T;  %period t
jv=1:NN; %index of non singular block
jv1=jv; %state variables to draw, 3, 5 are lagged states

p00=squeeze(ptt(i,jv1,jv1)); 
beta2(i,:)=beta_tt(i,:);
beta2(i,jv1)=mvnrnd(beta_tt(i:i,jv1),p00,1);%beta_tt(i:i,jv1)+(wa(i:i,jv1)*cholx(p00));   %draw for beta in period t from N(beta_tt,ptt)

error(i,:)=Y(i,:)-X(i,:)*reshape(beta2(i:i,1:NN),N*L+EX,N);  %var residuals

roots(i)=stability(beta2(i,1:NN)',N,L,EX);


%periods t-1..to .1

for i=T-1:-1:1
mu1=mu(jv);
f=F(jv,:); 
q=Q(jv,jv);

pt=squeeze(ptt(i,:,:));
bm=beta_tt(i:i,:)+(pt*f'*invpd(f*pt*f'+q)*(beta2(i+1:i+1,jv)-mu1-beta_tt(i,:)*f')')';  
pm=pt-pt*f'*invpd(f*pt*f'+q)*f*pt;  
beta2(i,:)=bm;
beta2(i:i,jv1)=mvnrnd(bm(jv1),pm(jv1,jv1),1);     %bm(jv1)+(wa(i:i,jv1)*cholx(pm(jv1,jv1)));  
error(i,:)=Y(i,:)-X(i,:)*reshape(beta2(i:i,1:NN),N*L+EX,N);  %var residuals

roots(i)=stability(beta2(i,1:NN)',N,L,EX);
end
if CHECK
if sum(roots)==0
    chck=1;
else
    trys=trys+1;
end
else
 chck=1;
end
end
if CHECK
    if chck<0
        problem=1;
    end
end