function[beta2,error,roots,problem]=...
    carterkohnvarFIXEDMS4(Y,X,Q,sigma1,sigma2,sigma3,sigma4,beta0,P00,L,CHECK,maxdraws,qt)
T=rows(Y);
N=cols(Y);
%%Step 2a Set up matrices for the Kalman Filter

ns=cols(beta0);
F=eye(ns);
mu=0;
beta_tt=zeros(T,ns);          %will hold the filtered state variable
ptt=zeros(T,ns,ns);    % will hold its variance
beta11=beta0;
p11=P00;


% %%%%%%%%%%%Step 2b run Kalman Filter

for i=1:T
   x=kron(eye(N),X(i,:));
if qt(i)==1
    R=sigma1;
elseif qt(i)==2
    R=sigma2;
elseif qt(i)==3;
    R=sigma3;
    elseif qt(i)==4;
    R=sigma4;
end
    %Prediction
beta10=mu+beta11*F';
p10=F*p11*F'+Q;
yhat=(x*(beta10)')';                                               
eta=Y(i,:)-yhat;
feta=(x*p10*x')+R;
%updating
K=(p10*x')*invpd(feta);
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);

ptt(i,:,:)=p11;
beta_tt(i,:)=beta11;

end


%%%%%%%%%%%end of Kalman Filter%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%step 2c Backward recursion to calculate the mean and variance of the distribution of the state
%vector
chck=-1;
problem=0;
trys=1;
while chck<0 && trys<=maxdraws
    
wa=randn(1,ns);
epsilon=zeros(T,N);
roots=zeros(1,1);

i=T;  %per
p00=squeeze(ptt(i,:,:)); 
beta2=beta_tt(i:i,:)+(wa*cholx(p00));   %draw for beta in period t from N(beta_tt,ptt)

roots=stability(beta2',N,L,1);

if CHECK
if sum(roots)==0
    chck=1;
else
    trys=trys+1;
end
else
 chck=1;
end
end
if CHECK
    if chck<0
        problem=1;
    end
end

error=Y-X*reshape(beta2,N*L+1,N);  %var residuals
