function [out,beta_tt]=draw_data3(A0t,beta2m,sigmam,dataid0,mid,beta0,P00,N,M)
ns=cols(beta0);
T=rows(dataid0);
%Carter and Kohn algorithm to draw the factor
beta_tt=zeros(T,ns);          %will hold the filtered state variable
ptt=zeros(T,ns,ns);    % will hold its variance
% %%%%%%%%%%%Step 6a run Kalman Filter
beta11=beta0;
p11=P00;
for i=1:T
nanid=mid(i,1); %checks if data on GDP is missing
if nanid==1 %missing
%  H=[0 0 0 0 0 0;
%     0 1 0  0  0  0];
H=[eye(M,ns);zeros(N-M,ns)];
  
    rr=zeros(1,N);
    rr(M+1:end)=1e10;  %big variance so missing data ignored
    R=diag(rr);
else  %valid  observation for first variable every 3rd month
%      H=[1 0 0 0 0 0;
%     0 1 0  0  0  0];
H=eye(N,ns);
rr=zeros(1,N);
R=diag(rr);
  
  
end
F=zeros(ns,ns);
MUx=zeros(1,ns);
A0=A0t(:,:,i);
A0big=zeros(N,N);
A0big(1:M,1:M)=A0;
A0big(N,1)=beta2m;
A0big(N,N)=sigmam.^0.5;
Q=zeros(ns,ns);
Q(1:N,1:N)=A0big*A0big';
x=H;
%Prediction
beta10=MUx+beta11*F';
p10=F*p11*F'+Q;
yhat=(x*(beta10)')';                                               
eta=dataid0(i,:)-yhat;
feta=(x*p10*x')+R;
%updating
K=(p10*x')*invpd(feta);
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);
ptt(i,:,:)=p11;
beta_tt(i,:)=beta11;
end
% Backward recursion to calculate the mean and variance of the distribution of the state
%vector
beta2 = zeros(T,ns);   %this will hold the draw of the state variable
bm2=beta2;
jv=1:N; %index of non singular block
jv1=M+1:N:ns; %state variables to draw, 3, 5 are lagged states

i=T;  %period t

p00=squeeze(ptt(i,jv1,jv1)); 
beta2(i,:)=beta_tt(i,:);
beta2(i,jv1)=mvnrnd(beta_tt(i:i,jv1),p00,1);%beta_tt(i:i,jv1)+(wa(i:i,jv1)*cholx(p00));   %draw for beta in period t from N(beta_tt,ptt)

%periods t-1..to .1
for i=T-1:-1:1

mu=MUx(jv);
f=F(jv,:); 
Q=zeros(ns,ns);
A0=A0t(:,:,i+1);
A0big=zeros(N,N);
A0big(1:M,1:M)=A0;
A0big(N,1)=beta2m;
A0big(N,N)=sigmam.^0.5;
Q=zeros(ns,ns);
Q(1:N,1:N)=A0big*A0big';
q=Q(jv,jv);
pt=squeeze(ptt(i,:,:));
bm=beta_tt(i:i,:)+(pt*f'*invpd(f*pt*f'+q)*(beta2(i+1:i+1,jv)-mu-beta_tt(i,:)*f')')';  
pm=pt-pt*f'*invpd(f*pt*f'+q)*f*pt;  
beta2(i,:)=bm;
beta2(i:i,jv1)=mvnrnd(bm(jv1),pm(jv1,jv1),1);     %bm(jv1)+(wa(i:i,jv1)*cholx(pm(jv1,jv1)));  
bm2(i,:)=bm;
end

out=beta2(:,M+1:N); %draw of monthly data

