function [out,dataid1]=draw_data_initial1(dataid0,mid,beta0,P00,N,M,bm,sm)
ns=N;
T=rows(dataid0);
yy=dataid0(:,1:M);
L=1;
xx=prepare(yy,L);
yy=yy(2:end,:);
xx=xx(2:end,:);
bols=xx\yy;
ee=yy-xx*bols;
sigma=(ee'*ee)/(rows(yy)-cols(xx));
A0=chol(sigma)';
A0big=zeros(N,N);
A0big(1:M,1:M)=A0;
A0big(end,1)=bm;
A0big(end,end)=sm.^0.5;
F=zeros(N,N);
MUx=zeros(1,N);
Q=zeros(ns,ns);
Q(1:N,1:N)=A0big*A0big';
dataid1=[[ee(1,:);ee] dataid0(:,end)];
%Carter and Kohn algorithm to draw the factor
beta_tt=zeros(T,ns);          %will hold the filtered state variable
ptt=zeros(T,ns,ns);    % will hold its variance
% %%%%%%%%%%%Step 6a run Kalman Filter
beta11=beta0;
p11=P00;
for i=1:T
nanid=mid(i,1); %checks if data on GDP is missing
if nanid==1 %missing
%  H=[0 0 0 0 0 0;
%     0 1 0  0  0  0];
H=[eye(M,ns);zeros(N-M,ns)];
  
    rr=zeros(1,N);
    rr(M+1:end)=1e10;  %big variance so missing data ignored
    R=diag(rr);
else  %valid  observation for first variable every 3rd month
%      H=[1 0 0 0 0 0;
%     0 1 0  0  0  0];
H=eye(N,ns);
rr=zeros(1,N);
R=diag(rr);
  
  
end


x=H;
%Prediction
beta10=MUx+beta11*F';
p10=F*p11*F'+Q;
yhat=(x*(beta10)')';                                               
eta=dataid1(i,:)-yhat;
feta=(x*p10*x')+R;
%updating
K=(p10*x')*invpd(feta);
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);
ptt(i,:,:)=p11;
beta_tt(i,:)=beta11;
end


%%%%%%%%Kalman Smoother%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 beta_TT=zeros(T,ns); %will hold smoothed state
MU=MUx;
pTT=zeros(T,ns,ns);   %will hold covariance of smoothed stat
i=T;   %time period T
 beta_TT(i,:)=beta_tt(i,:); %smoothed state for T
 pTT(i,:,:)=ptt(i,:,:); %Its covariance for T

 for i=T-1:-1:1  %go backward in time
    
     pnext=F*squeeze(ptt(i,:,:))*F'+Q;
     ipnext=pinv(pnext);
     pcurrent=squeeze(ptt(i,:,:));
     pTTcurrent=squeeze(pTT(i+1,:,:));
     beta12=beta_tt(i,:)+(pcurrent*F'*ipnext*(beta_TT(i+1,:)-beta_tt(i,:)*F'-MU)')';
     p12=pcurrent+pcurrent*F'*ipnext*(pTTcurrent-pnext)*ipnext'*F*pcurrent';
     beta_TT(i,:)=beta12;
     pTT(i,:,:)=p12;
     
 end
out=beta_TT(:,1:N);

