function [fsave,bdic]=...
    estimate2regimesC(data,VarBench,HORZ,REPS,BURN,MaxTrys,fprob,T0,filex)


% Redefine paras (just to use shorter names):
L       = VarBench.L;
lamdaP  = VarBench.lamdaP;
tauP    = VarBench.tauP;
epsilonP= VarBench.epsilonP;
CHECK=1;

% Get input data    


Y=data;
N=cols(Y);
ncrit=(N*L+1);

%take lags
X=[];
for j=1:L
X=[X lag0(Y,j) ];
end
X=[X ones(rows(X),1)];


Y=Y(T0+1:end,:);
X=X(T0+1:end,:);

T=rows(Y);
%starting values
[ s00x ] = fprob(1:T,2)>0.5;
s00x(1:ncrit)=zeros(ncrit,1);


% Additional priors for VAR coefficients
muP=mean(Y)';
sigmaP=[];
deltaP=[];
e0=[];
for i=1:N
    ytemp=Y(:,i);
    xtemp=[lag0(ytemp,1) ones(rows(ytemp),1)];
    ytemp=ytemp(2:end,:);
    xtemp=xtemp(2:end,:);
    btemp=xtemp\ytemp;
    etemp=ytemp-xtemp*btemp;
    stemp=etemp'*etemp/rows(ytemp);
    if abs(btemp(1))>1
        btemp(1)=1;
    end
    deltaP=[deltaP;btemp(1)];
    sigmaP=[sigmaP;stemp];
    e0=[e0 etemp];
end

%dummy data to implement priors see http://ideas.repec.org/p/ecb/ecbwps/20080966.html
[yd,xd,beta0,P00] = create_dummies(lamdaP,tauP,deltaP,epsilonP,L,muP,sigmaP,N);

%set priors for transition probability equation

u11=15;u12=1;u22=15;u21=1;
v11=15;v12=1;v22=15;v21=1;




%starting values to intialise the Gibbs algorithm
si=s00x(1:T);
qi=si;
s00=si;
q00=qi;
pp=0.95;
qq=1;

ppv=0.95;
qqv=1;

ymat1=Y(si==0,:);
xmat1=X(si==0,:);
btemp1=xmat1\ymat1;
etemp1=ymat1-xmat1*btemp1;
sig1=(etemp1'*etemp1)/rows(etemp1);

ymat2=Y(si==1,:);
xmat2=X(si==1,:);
btemp2=xmat2\ymat2;
etemp2=ymat2-xmat2*btemp2;
sig2=(etemp2'*etemp2)/rows(etemp2);

alpha=X\Y;
alpha1=vec(alpha);
alpha2=vec(alpha);





fsave=zeros(REPS-BURN,HORZ,N); 

   
   bsave1=zeros(REPS-BURN,N*(N*L+1));
   bsave2=zeros(REPS-BURN,N*(N*L+1));
   sigmaS1=zeros(REPS-BURN,N,N);

   
   regime=zeros(REPS-BURN,T);

   psave=zeros(REPS-BURN,2,2);
 
   lik=zeros(REPS-BURN,1);
varcoef1=reshape(alpha1,N*L+1,N);
varcoef2=reshape(alpha2,N*L+1,N);
alpha10=alpha1;
alpha20=alpha2;
igibbs=1;
  jgibbs=0;
while jgibbs<REPS-BURN

%step 1 : Draw St

 [fprob,likx]=hamiltonfilterIDbeta(varcoef1,varcoef2,sig1,sig1,pp,qq,Y,X,ones(T,1));
 
 [si,problems]=getS(fprob,pp,qq,ncrit,MaxTrys);
 if problems
   si=s00;
 else
     s00=si;
 end



%draw VAR coefficients

ymat1=Y(si==0,:);
xmat1=X(si==0,:);


ymat2=Y(si==1,:);
xmat2=X(si==1,:);



[alpha1,error1,roots1,problema1]=...
    carterkohnvarFIXEDMS2(ymat1,xmat1,0,sig1,sig1,beta0',P00,L,CHECK,MaxTrys,ones(rows(ymat1),1));
if problema1
alpha1=alpha10;
else
alpha10=alpha1;
end

[alpha2,error2,roots2,problema2]=...
    carterkohnvarFIXEDMS2(ymat2,xmat2,0,sig1,sig1,beta0',P00,L,CHECK,MaxTrys,ones(rows(ymat2),1));

if problema2
alpha2=alpha20;
else
alpha20=alpha2;
end
% [problema1 problema2]
varcoef1=reshape(alpha1,N*L+1,N);
varcoef2=reshape(alpha2,N*L+1,N);

     
     
     
   %draw VAR covariance 
  evar=((Y-X*varcoef1).*repmat(si==0,1,N))+(Y-X*varcoef2).*repmat(si==1,1,N);
  evard1=yd-xd*reshape(beta0,N*L+1,N);

  evar1=[evar;evard1];
  
  
       scale1=evar1'*evar1;
    sig1=iwpq(rows(evar1),invpd(scale1)); 
    

    

  %draw transition probabilities

    tranmat=switchg(si+1,[1;2]);
    N11=tranmat(1,1);
    N12=tranmat(1,2);
    N21=tranmat(2,1);
    N22=tranmat(2,2);
    %draw from the dirichlet density
    p0=drchrnd([N11+u11;N12+u12]);
    pp=p0(1,1);
    qq=1;
    
     
     disp(sprintf('    Replication %s of %s  ' , ... 
             num2str([igibbs jgibbs]), num2str([ REPS filex])));
%     [problema1 problema2 problems problemsv]

    if igibbs>BURN && ~problema1 &&~ problema2 && ~problems 


         jgibbs=jgibbs+1;
         % Simulate and store forward paths:
   pr_tr=[pp (1-qq); (1-pp) qq];


[ yhat] = getforecast2C( VarBench,HORZ,N,Y,varcoef1,varcoef2,sig1,fprob,pr_tr);
 fsave(jgibbs,:,:)=yhat(L+1:end,:);
     
    bsave1(jgibbs,:)=alpha1';
   bsave2(jgibbs,:)=alpha2';
   sigmaS1(jgibbs,:,:)=sig1;
  
   psave(jgibbs,:,:)=pr_tr;

   regime(jgibbs,:)=si';

   lik(jgibbs)=likx;
   


     end
     igibbs=igibbs+1;
end


   alpha1m=mean(bsave1);
   alpha2m=mean(bsave2);
   sig1m=squeeze(mean(sigmaS1,1));
 
   pm=squeeze(mean(psave,1));

   
   varcoef1m=reshape(alpha1m,N*L+1,N);
varcoef2m=reshape(alpha2m,N*L+1,N);
 [fprobxm,likm]=hamiltonfilterIDbeta(varcoef1m,varcoef2m,sig1m,sig1m,pm(1,1),pm(2,2),...
     Y,X,ones(T,1));

%compute DIC
ee=isinf(lik) | isnan(lik);
lik1=lik(ee==0);
params=mean(-2*lik1)-(-2*likm);
bdic=mean(-2*lik1)+params;