function [fsave,bdic,regime]=...
    estimate3regimesC(data,VarBench,HORZ,REPS,BURN,MaxTrys,fprob,T0,filex)


% Redefine paras (just to use shorter names):
L       = VarBench.L;
lamdaP  = VarBench.lamdaP;
tauP    = VarBench.tauP;
epsilonP= VarBench.epsilonP;
CHECK=1;

% Get input data    


Y=data;
N=cols(Y);
ncrit=(N*L+1);

%take lags
X=[];
for j=1:L
X=[X lag0(Y,j) ];
end
X=[X ones(rows(X),1)];


Y=Y(T0+1:end,:);
X=X(T0+1:end,:);

T=rows(Y);
%starting values
e1=fprob(1:T,1)>0.5;
e2=fprob(1:T,2)>0.5;
e3=fprob(1:T,3)>0.5;
s00x=e1+e2*2+e3*3;
s00x(T-(ncrit*2)+1:T-ncrit)=ones(ncrit,1)*2;
s00x(T-ncrit+1:T)=ones(ncrit,1)*3;


% Additional priors for VAR coefficients
muP=mean(Y)';
sigmaP=[];
deltaP=[];
e0=[];
for i=1:N
    ytemp=Y(:,i);
    xtemp=[lag0(ytemp,1) ones(rows(ytemp),1)];
    ytemp=ytemp(2:end,:);
    xtemp=xtemp(2:end,:);
    btemp=xtemp\ytemp;
    etemp=ytemp-xtemp*btemp;
    stemp=etemp'*etemp/rows(ytemp);
    if abs(btemp(1))>1
        btemp(1)=1;
    end
    deltaP=[deltaP;btemp(1)];
    sigmaP=[sigmaP;stemp];
    e0=[e0 etemp];
end

%dummy data to implement priors see http://ideas.repec.org/p/ecb/ecbwps/20080966.html
[yd,xd,beta0,P00] = create_dummies(lamdaP,tauP,deltaP,epsilonP,L,muP,sigmaP,N);

%set priors for transition probability equation

u11=15;u12=1;u13=1;
u22=15;u21=1;u23=1;
u31=1;u32=1;u33=1;
v11=15;v12=1;v13=1;
v22=15;v21=1;v23=1;
v31=1;v32=1;v33=1;




%starting values to intialise the Gibbs algorithm
si=s00x(1:T);
qi=si;
s00=si;
q00=qi;


ymat1=Y(si==1,:);
xmat1=X(si==1,:);
btemp1=xmat1\ymat1;
etemp1=ymat1-xmat1*btemp1;
sig1=(etemp1'*etemp1)/rows(etemp1);

ymat2=Y(si==2,:);
xmat2=X(si==2,:);
btemp2=xmat2\ymat2;
etemp2=ymat2-xmat2*btemp2;
sig2=(etemp2'*etemp2)/rows(etemp2);

ymat3=Y(si==3,:);
xmat3=X(si==3,:);
btemp3=xmat3\ymat3;
etemp3=ymat3-xmat3*btemp3;
sig3=(etemp3'*etemp3)/rows(etemp3);


alpha=X\Y;
alpha1=vec(alpha);
alpha2=vec(alpha);
alpha3=vec(alpha);





fsave=zeros(REPS-BURN,HORZ,N); 

   
   bsave1=zeros(REPS-BURN,N*(N*L+1));
   bsave2=zeros(REPS-BURN,N*(N*L+1));
     bsave3=zeros(REPS-BURN,N*(N*L+1));
   sigmaS1=zeros(REPS-BURN,N,N);
  
   
   regime=zeros(REPS-BURN,T);

   psave=zeros(REPS-BURN,3,3);

   lik=zeros(REPS-BURN,1);
varcoef1=reshape(alpha1,N*L+1,N);
varcoef2=reshape(alpha2,N*L+1,N);
varcoef3=reshape(alpha3,N*L+1,N);

alpha10=alpha1;
alpha20=alpha2;
alpha30=alpha3;
qi=ones(T,1);
igibbs=1;
  jgibbs=0;
while jgibbs<REPS-BURN




%draw VAR coefficients

ymat1=Y(si==1,:);
xmat1=X(si==1,:);
qt1=qi(si==1);

ymat2=Y(si==2,:);
xmat2=X(si==2,:);
qt2=qi(si==2);

ymat3=Y(si==3,:);
xmat3=X(si==3,:);
qt3=qi(si==3);

[alpha1,error1,roots1,problema1]=...
    carterkohnvarFIXEDMS3(ymat1,xmat1,0,sig1,sig1,sig1,beta0',P00,L,CHECK,MaxTrys,qt1);
if problema1
alpha1=alpha10;
else
alpha10=alpha1;
end

[alpha2,error2,roots2,problema2]=...
    carterkohnvarFIXEDMS3(ymat2,xmat2,0,sig1,sig1,sig1,beta0',P00,L,CHECK,MaxTrys,qt2);

if problema2
alpha2=alpha20;
else
alpha20=alpha2;
end

[alpha3,error3,roots3,problema3]=...
    carterkohnvarFIXEDMS3(ymat3,xmat3,0,sig1,sig1,sig1,beta0',P00,L,CHECK,MaxTrys,qt3);

if problema3
alpha3=alpha30;
else
alpha30=alpha3;
end




% [problema1 problema2]
varcoef1=reshape(alpha1,N*L+1,N);
varcoef2=reshape(alpha2,N*L+1,N);
varcoef3=reshape(alpha3,N*L+1,N);

     
     
     
   %draw VAR covariance 
  evar=((Y-X*varcoef1).*repmat(si==1,1,N))+(Y-X*varcoef2).*repmat(si==2,1,N)+...
      (Y-X*varcoef3).*repmat(si==3,1,N);
  evard1=yd-xd*reshape(beta0,N*L+1,N);


  evar1=[evar;evard1];


  
       scale1=evar1'*evar1;
    sig1=iwpq(rows(evar1),invpd(scale1)); 
    
    
  %draw transition probabilities

    tranmat=switchg(si,[1;2;3]);
    N11=tranmat(1,1);N12=tranmat(1,2);N13=tranmat(1,3);
    N21=tranmat(2,1);N22=tranmat(2,2);N23=tranmat(2,3);
    N31=tranmat(3,1);N32=tranmat(3,2);N33=tranmat(3,3);
    %draw from the dirichlet density
    p0=drchrnd([N11+u11;N12+u12]);
    p11=p0(1,1);
    p12=1-p11;
    p13=0;
   p0=drchrnd([N22+u22;N23+u23]);
   p21=0;
   p22=p0(1,1);
   p23=1-p22;
  
   p31=0;
   p32=0;
   p33=1;
  
      
    
    %step 1 : Draw St
 pvec=[p11;p12;p13;p21;p22;p23;p31;p32;p33];
 [fprob,likx]=...
     hamiltonfilterIDbeta3(varcoef1,varcoef2,varcoef3,sig1,sig1,sig1,pvec,Y,X,qi);
 
 [si,problems]=getS3(fprob,pvec,ncrit,MaxTrys);
 if problems
   si=s00;
 else
     s00=si;
 end

    
     disp(sprintf('    Replication %s of %s  ' , ... 
             num2str([igibbs jgibbs]), num2str([ REPS filex])));
%     [problema1 problema2 problems problemsv]

    if igibbs>BURN && ~problema1 &&~ problema2 && ~problema3 && ~problems 


         jgibbs=jgibbs+1;
         % Simulate and store forward paths:
   pr_tr=reshape(pvec,3,3);

[ yhat] = getforecast3C( VarBench,HORZ,N,Y,varcoef1,varcoef2,varcoef3,sig1,fprob,pr_tr);
 fsave(jgibbs,:,:)=yhat(L+1:end,:);
     
    bsave1(jgibbs,:)=alpha1';
   bsave2(jgibbs,:)=alpha2';
      bsave3(jgibbs,:)=alpha3';

   sigmaS1(jgibbs,:,:)=sig1;
   

   psave(jgibbs,:,:)=pr_tr;
   regime(jgibbs,:)=si';
   lik(jgibbs)=likx;
   


     end
     igibbs=igibbs+1;
end


   alpha1m=mean(bsave1);
   alpha2m=mean(bsave2);
   alpha3m=mean(bsave3);
   sig1m=squeeze(mean(sigmaS1,1));
  
   pm=squeeze(mean(psave,1));
   
   varcoef1m=reshape(alpha1m,N*L+1,N);
varcoef2m=reshape(alpha2m,N*L+1,N);
varcoef3m=reshape(alpha3m,N*L+1,N);
 [fprobm,likm]=...
     hamiltonfilterIDbeta3(varcoef1m,varcoef2m,varcoef3m,sig1m,sig1m,sig1m,vec(pm),Y,X,qi);
%compute DIC
ee=isinf(lik) | isnan(lik);
lik1=lik(ee==0);
params=mean(-2*lik1)-(-2*likm);
bdic=mean(-2*lik1)+params;