function [fsave,bdic,bsave1,bsave2,sigmaS1,sigmaS2,regime,regimev,psave,qsave]=...
    estimate4regimes(data,VarBench,HORZ,REPS,BURN,MaxTrys,fprob,T0,filex)


% Redefine paras (just to use shorter names):
L       = VarBench.L;
lamdaP  = VarBench.lamdaP;
tauP    = VarBench.tauP;
epsilonP= VarBench.epsilonP;
CHECK=1;

% Get input data    


Y=data;
N=cols(Y);
ncrit=(N*L+1);

%take lags
X=[];
for j=1:L
X=[X lag0(Y,j) ];
end
X=[X ones(rows(X),1)];


Y=Y(T0+1:end,:);
X=X(T0+1:end,:);

T=rows(Y);
%starting values
e1=fprob(1:T,1)>0.5;
e2=fprob(1:T,2)>0.5;
e3=fprob(1:T,3)>0.5;
e4=fprob(1:T,4)>0.5;
s00x=e1+e2*2+e3*3+e4*4;
s00x(T-(ncrit*3)+1:T-(ncrit*2))=ones(ncrit,1)*2;
s00x(T-(ncrit*2)+1:T-ncrit)=ones(ncrit,1)*3;
s00x(T-ncrit+1:T)=ones(ncrit,1)*4;


% Additional priors for VAR coefficients
muP=mean(Y)';
sigmaP=[];
deltaP=[];
e0=[];
for i=1:N
    ytemp=Y(:,i);
    xtemp=[lag0(ytemp,1) ones(rows(ytemp),1)];
    ytemp=ytemp(2:end,:);
    xtemp=xtemp(2:end,:);
    btemp=xtemp\ytemp;
    etemp=ytemp-xtemp*btemp;
    stemp=etemp'*etemp/rows(ytemp);
    if abs(btemp(1))>1
        btemp(1)=1;
    end
    deltaP=[deltaP;btemp(1)];
    sigmaP=[sigmaP;stemp];
    e0=[e0 etemp];
end

%dummy data to implement priors see http://ideas.repec.org/p/ecb/ecbwps/20080966.html
[yd,xd,beta0,P00] = create_dummies(lamdaP,tauP,deltaP,epsilonP,L,muP,sigmaP,N);

%set priors for transition probability equation

u11=15;u12=1;u13=1;u14=1;
u22=15;u21=1;u23=1;u24=1;
u31=1;u32=1;u33=15;u34=1;

v11=15;v12=1;v13=1;v14=1;
v22=15;v21=1;v23=1;v24=1;
v31=1;v32=1;v33=15;v34=1;





%starting values to intialise the Gibbs algorithm
si=s00x(1:T);
qi=si;
s00=si;
q00=qi;


ymat1=Y(si==1,:);
xmat1=X(si==1,:);
btemp1=xmat1\ymat1;
etemp1=ymat1-xmat1*btemp1;
sig1=(etemp1'*etemp1)/rows(etemp1);

ymat2=Y(si==2,:);
xmat2=X(si==2,:);
btemp2=xmat2\ymat2;
etemp2=ymat2-xmat2*btemp2;
sig2=(etemp2'*etemp2)/rows(etemp2);

ymat3=Y(si==3,:);
xmat3=X(si==3,:);
btemp3=xmat3\ymat3;
etemp3=ymat3-xmat3*btemp3;
sig3=(etemp3'*etemp3)/rows(etemp3);

ymat4=Y(si==4,:);
xmat4=X(si==4,:);
btemp4=xmat4\ymat4;
etemp4=ymat4-xmat4*btemp4;
sig4=(etemp4'*etemp4)/rows(etemp4);


alpha=X\Y;
alpha1=vec(alpha);
alpha2=vec(alpha);
alpha3=vec(alpha);
alpha4=vec(alpha);




fsave=zeros(REPS-BURN,HORZ,N); 

   
   bsave1=zeros(REPS-BURN,N*(N*L+1));
   bsave2=zeros(REPS-BURN,N*(N*L+1));
     bsave3=zeros(REPS-BURN,N*(N*L+1));
     bsave4=zeros(REPS-BURN,N*(N*L+1));
   sigmaS1=zeros(REPS-BURN,N,N);
   sigmaS2=zeros(REPS-BURN,N,N);
   sigmaS3=zeros(REPS-BURN,N,N);
     sigmaS4=zeros(REPS-BURN,N,N);
   regime=zeros(REPS-BURN,T);
   regimev=regime;
   psave=zeros(REPS-BURN,4,4);
  qsave=zeros(REPS-BURN,4,4);
   lik=zeros(REPS-BURN,1);
varcoef1=reshape(alpha1,N*L+1,N);
varcoef2=reshape(alpha2,N*L+1,N);
varcoef3=reshape(alpha3,N*L+1,N);
varcoef4=reshape(alpha4,N*L+1,N);
alpha10=alpha1;
alpha20=alpha2;
alpha30=alpha3;
alpha40=alpha4;
igibbs=1;
  jgibbs=0;
while jgibbs<REPS-BURN




%draw VAR coefficients

ymat1=Y(si==1,:);
xmat1=X(si==1,:);
qt1=qi(si==1);

ymat2=Y(si==2,:);
xmat2=X(si==2,:);
qt2=qi(si==2);

ymat3=Y(si==3,:);
xmat3=X(si==3,:);
qt3=qi(si==3);

ymat4=Y(si==4,:);
xmat4=X(si==4,:);
qt4=qi(si==4);




[alpha1,error1,roots1,problema1]=...
    carterkohnvarFIXEDMS4(ymat1,xmat1,0,sig1,sig2,sig3,sig4,beta0',P00,L,CHECK,MaxTrys,qt1);
if problema1
alpha1=alpha10;
else
alpha10=alpha1;
end

[alpha2,error2,roots2,problema2]=...
    carterkohnvarFIXEDMS4(ymat2,xmat2,0,sig1,sig2,sig3,sig4,beta0',P00,L,CHECK,MaxTrys,qt2);

if problema2
alpha2=alpha20;
else
alpha20=alpha2;
end

[alpha3,error3,roots3,problema3]=...
    carterkohnvarFIXEDMS4(ymat3,xmat3,0,sig1,sig2,sig3,sig4,beta0',P00,L,CHECK,MaxTrys,qt3);

if problema3
alpha3=alpha30;
else
alpha30=alpha3;
end

[alpha4,error4,roots4,problema4]=...
    carterkohnvarFIXEDMS4(ymat4,xmat4,0,sig1,sig2,sig3,sig4,beta0',P00,L,CHECK,MaxTrys,qt4);

if problema4
alpha4=alpha40;
else
alpha40=alpha4;
end


% [problema1 problema2]
varcoef1=reshape(alpha1,N*L+1,N);
varcoef2=reshape(alpha2,N*L+1,N);
varcoef3=reshape(alpha3,N*L+1,N);
varcoef4=reshape(alpha4,N*L+1,N);

     
     
     
   %draw VAR covariance 
  evar=((Y-X*varcoef1).*repmat(si==1,1,N))+(Y-X*varcoef2).*repmat(si==2,1,N)+...
      (Y-X*varcoef3).*repmat(si==3,1,N)+ (Y-X*varcoef4).*repmat(si==4,1,N);
  evard1=yd-xd*reshape(beta0,N*L+1,N);
  evard2=yd-xd*reshape(beta0,N*L+1,N);
  evard3=yd-xd*reshape(beta0,N*L+1,N);
  evard4=yd-xd*reshape(beta0,N*L+1,N);

  evar1=[evar(qi==1,:);evard1];
  evar2=[evar(qi==2,:);evard2];
  evar3=[evar(qi==3,:);evard3]; 
  evar4=[evar(qi==4,:);evard4];

  

  
       scale1=evar1'*evar1;
    sig1=iwpq(rows(evar1),invpd(scale1)); 
    
      scale2=evar2'*evar2;
    sig2=iwpq(rows(evar2),invpd(scale2));  
    
    scale3=evar3'*evar3;
    sig3=iwpq(rows(evar3),invpd(scale3)); 
    
        scale4=evar4'*evar4;
    sig4=iwpq(rows(evar4),invpd(scale4)); 
  %draw transition probabilities

    tranmat=switchg(si,[1;2;3;4]);
    N11=tranmat(1,1);N12=tranmat(1,2);N13=tranmat(1,3);N14=tranmat(1,4);
    N21=tranmat(2,1);N22=tranmat(2,2);N23=tranmat(2,3);N24=tranmat(2,4);
    N31=tranmat(3,1);N32=tranmat(3,2);N33=tranmat(3,3);N34=tranmat(3,4);
    N41=tranmat(4,1);N42=tranmat(4,2);N43=tranmat(4,3);N44=tranmat(4,4);
    %draw from the dirichlet density
    p0=drchrnd([N11+u11;N12+u12]);
    p11=p0(1,1);
    p12=1-p11;
    p13=0;
    p14=0;
   p0=drchrnd([N22+u22;N23+u23]);
   p21=0;
   p22=p0(1,1);
   p23=1-p22;
   p24=0;
  
   p0=drchrnd([N33+u33;N34+u34]);
   p31=0;
   p32=0;
   p33=p0(1,1);
   p34=1-p33;
   
   p41=0;
   p42=0;
   p43=0;
   p44=1;
  
      %draw transition probabilities variance

    tranmatv=switchg(qi,[1;2;3;4]);
  N11v=tranmatv(1,1);N12v=tranmatv(1,2);N13v=tranmatv(1,3);N14v=tranmatv(1,4);
    N21v=tranmatv(2,1);N22v=tranmatv(2,2);N23v=tranmatv(2,3);N24v=tranmatv(2,4);
    N31v=tranmatv(3,1);N32v=tranmatv(3,2);N33v=tranmatv(3,3);N34v=tranmatv(3,4);
    N41v=tranmatv(4,1);N42v=tranmatv(4,2);N43v=tranmatv(4,3);N44v=tranmatv(4,4);
    %draw from the dirichlet density
    p0=drchrnd([N11v+v11;N12v+v12]);
    q11=p0(1,1);
    q12=1-q11;
    q13=0;
    q14=0;
   p0=drchrnd([N22v+v22;N23v+v23]);
   q21=0;
   q22=p0(1,1);
   q23=1-q22;
   q24=0;
  
      p0=drchrnd([N33v+v33;N34v+v34]);
   q31=0;
   q32=0;
   q33=p0(1,1);
   q34=1-q33;
   
   q41=0;
   q42=0;
   q43=0;
   q44=1;
    
    
    %step 1 : Draw St
 pvec=[p11;p12;p13;p14;p21;p22;p23;p24;p31;p32;p33;p34;p41;p42;p43;p44];
 [fprob,liki]=...
     hamiltonfilterIDbeta4(varcoef1,varcoef2,varcoef3,varcoef4,sig1,sig2,sig3,sig4,pvec,Y,X,qi);
 
 [si,problems]=getS4(fprob,pvec,ncrit,MaxTrys);
 if problems
   si=s00;
 else
     s00=si;
 end

 %step 2 draw Qt
  qvec=[q11;q12;q13;q14;q21;q22;q23;q24;q31;q32;q33;q34;q41;q42;q43;q44];

  [fprobv,likiv]=hamiltonfilterIDsigma4(varcoef1,varcoef2,varcoef3,varcoef4,...
      sig1,sig2,sig3,sig4,qvec,Y,X,si);
 
 [qi,problemsv]=getS4(fprobv,qvec,ncrit,MaxTrys);
 if problemsv
   qi=q00;
 else
     q00=qi;
 end
    
    
    
    
    
    
    
    
    
    
     disp(sprintf('    Replication %s of %s  ' , ... 
             num2str([igibbs jgibbs]), num2str([ REPS filex])));
%     [problema1 problema2 problems problemsv]

    if igibbs>BURN && ~problema1 &&~ problema2 && ~problema3 &&~problema4 && ~problems && ~problemsv


         jgibbs=jgibbs+1;
         % Simulate and store forward paths:
   pr_tr=reshape(pvec,4,4);
   qr_tr=reshape(qvec,4,4);
      [fprobx,likx]=getlikelihoodI4(varcoef1,varcoef2,varcoef3,varcoef4,sig1,sig2,sig3,sig4,pr_tr,qr_tr,Y,X);

[ yhat] = getforecast4( VarBench,HORZ,N,Y,varcoef1,varcoef2,varcoef3,varcoef4,sig1,sig2,sig3,sig4,fprobx,pr_tr,qr_tr);
 fsave(jgibbs,:,:)=yhat(L+1:end,:);
     
    bsave1(jgibbs,:)=alpha1';
   bsave2(jgibbs,:)=alpha2';
      bsave3(jgibbs,:)=alpha3';
      bsave4(jgibbs,:)=alpha4';
   sigmaS1(jgibbs,:,:)=sig1;
   sigmaS2(jgibbs,:,:)=sig2; 
      sigmaS3(jgibbs,:,:)=sig3; 
        sigmaS4(jgibbs,:,:)=sig4;  

   psave(jgibbs,:,:)=pr_tr;
   qsave(jgibbs,:,:)=qr_tr;
   regime(jgibbs,:)=si';
   regimev(jgibbs,:)=qi';
   lik(jgibbs)=likx;
   


     end
     igibbs=igibbs+1;
end


   alpha1m=mean(bsave1);
   alpha2m=mean(bsave2);
   alpha3m=mean(bsave3);
   alpha4m=mean(bsave4);
   sig1m=squeeze(mean(sigmaS1,1));
   sig2m=squeeze(mean(sigmaS2,1));
   sig3m=squeeze(mean(sigmaS3,1));
    sig4m=squeeze(mean(sigmaS4,1));
   pm=squeeze(mean(psave,1));
   qm=squeeze(mean(qsave,1));
   
   varcoef1m=reshape(alpha1m,N*L+1,N);
varcoef2m=reshape(alpha2m,N*L+1,N);
varcoef3m=reshape(alpha3m,N*L+1,N);
varcoef4m=reshape(alpha4m,N*L+1,N);
[fprobxm,likm]=getlikelihoodI4(varcoef1m,varcoef2m,varcoef3m,varcoef4m,sig1m,sig2m,sig3m,sig4m,pm,qm,Y,X);

%compute DIC
ee=isinf(lik) | isnan(lik);
lik1=lik(ee==0);
params=mean(-2*lik1)-(-2*likm);
bdic=mean(-2*lik1)+params;