function [fsave,bdic]=...
    estimate4regimesvar(data,VarBench,HORZ,REPS,BURN,MaxTrys,fprob,T0,filex)


% Redefine paras (just to use shorter names):
L       = VarBench.L;
lamdaP  = VarBench.lamdaP;
tauP    = VarBench.tauP;
epsilonP= VarBench.epsilonP;
CHECK=1;

% Get input data    


Y=data;
N=cols(Y);
ncrit=(N*L+1);

%take lags
X=[];
for j=1:L
X=[X lag0(Y,j) ];
end
X=[X ones(rows(X),1)];


Y=Y(T0+1:end,:);
X=X(T0+1:end,:);

T=rows(Y);
%starting values
e1=fprob(1:T,1)>0.5;
e2=fprob(1:T,2)>0.5;
e3=fprob(1:T,3)>0.5;
e4=fprob(1:T,4)>0.5;
s00x=e1+e2*2+e3*3+e4*4;
s00x(T-(ncrit*3)+1:T-(ncrit*2))=ones(ncrit,1)*2;
s00x(T-(ncrit*2)+1:T-ncrit)=ones(ncrit,1)*3;
s00x(T-ncrit+1:T)=ones(ncrit,1)*4;


% Additional priors for VAR coefficients
muP=mean(Y)';
sigmaP=[];
deltaP=[];
e0=[];
for i=1:N
    ytemp=Y(:,i);
    xtemp=[lag0(ytemp,1) ones(rows(ytemp),1)];
    ytemp=ytemp(2:end,:);
    xtemp=xtemp(2:end,:);
    btemp=xtemp\ytemp;
    etemp=ytemp-xtemp*btemp;
    stemp=etemp'*etemp/rows(ytemp);
    if abs(btemp(1))>1
        btemp(1)=1;
    end
    deltaP=[deltaP;btemp(1)];
    sigmaP=[sigmaP;stemp];
    e0=[e0 etemp];
end

%dummy data to implement priors see http://ideas.repec.org/p/ecb/ecbwps/20080966.html
[yd,xd,beta0,P00] = create_dummies(lamdaP,tauP,deltaP,epsilonP,L,muP,sigmaP,N);

%set priors for transition probability equation

u11=15;u12=1;u13=1;u14=1;
u22=15;u21=1;u23=1;u24=1;
u31=1;u32=1;u33=15;u34=1;

v11=15;v12=1;v13=1;v14=1;
v22=15;v21=1;v23=1;v24=1;
v31=1;v32=1;v33=15;v34=1;





%starting values to intialise the Gibbs algorithm
si=s00x(1:T);
qi=si;
s00=si;
q00=qi;


ymat1=Y(si==1,:);
xmat1=X(si==1,:);
btemp1=xmat1\ymat1;
etemp1=ymat1-xmat1*btemp1;
sig1=(etemp1'*etemp1)/rows(etemp1);

ymat2=Y(si==2,:);
xmat2=X(si==2,:);
btemp2=xmat2\ymat2;
etemp2=ymat2-xmat2*btemp2;
sig2=(etemp2'*etemp2)/rows(etemp2);

ymat3=Y(si==3,:);
xmat3=X(si==3,:);
btemp3=xmat3\ymat3;
etemp3=ymat3-xmat3*btemp3;
sig3=(etemp3'*etemp3)/rows(etemp3);

ymat4=Y(si==4,:);
xmat4=X(si==4,:);
btemp4=xmat4\ymat4;
etemp4=ymat4-xmat4*btemp4;
sig4=(etemp4'*etemp4)/rows(etemp4);


alpha=X\Y;
alpha1=vec(alpha);




fsave=zeros(REPS-BURN,HORZ,N); 

   
   bsave1=zeros(REPS-BURN,N*(N*L+1));
  
   sigmaS1=zeros(REPS-BURN,N,N);
   sigmaS2=zeros(REPS-BURN,N,N);
   sigmaS3=zeros(REPS-BURN,N,N);
     sigmaS4=zeros(REPS-BURN,N,N);
   regime=zeros(REPS-BURN,T);
   regimev=regime;

  qsave=zeros(REPS-BURN,4,4);
   lik=zeros(REPS-BURN,1);
varcoef1=reshape(alpha1,N*L+1,N);

alpha10=alpha1;

igibbs=1;
  jgibbs=0;
while jgibbs<REPS-BURN




%draw VAR coefficients





[alpha1,error1,roots1,problema1]=...
    carterkohnvarFIXEDMS4(Y,X,0,sig1,sig2,sig3,sig4,beta0',P00,L,CHECK,MaxTrys,qi);
if problema1
alpha1=alpha10;
else
alpha10=alpha1;
end



% [problema1 problema2]
varcoef1=reshape(alpha1,N*L+1,N);


     
     
     
   %draw VAR covariance 
  evar=((Y-X*varcoef1));
  evard1=yd-xd*reshape(beta0,N*L+1,N);
  evard2=yd-xd*reshape(beta0,N*L+1,N);
  evard3=yd-xd*reshape(beta0,N*L+1,N);
  evard4=yd-xd*reshape(beta0,N*L+1,N);

  evar1=[evar(qi==1,:);evard1];
  evar2=[evar(qi==2,:);evard2];
  evar3=[evar(qi==3,:);evard3]; 
  evar4=[evar(qi==4,:);evard4];

  

  
       scale1=evar1'*evar1;
    sig1=iwpq(rows(evar1),invpd(scale1)); 
    
      scale2=evar2'*evar2;
    sig2=iwpq(rows(evar2),invpd(scale2));  
    
    scale3=evar3'*evar3;
    sig3=iwpq(rows(evar3),invpd(scale3)); 
    
        scale4=evar4'*evar4;
    sig4=iwpq(rows(evar4),invpd(scale4)); 
 
  
      %draw transition probabilities variance

    tranmatv=switchg(qi,[1;2;3;4]);
  N11v=tranmatv(1,1);N12v=tranmatv(1,2);N13v=tranmatv(1,3);N14v=tranmatv(1,4);
    N21v=tranmatv(2,1);N22v=tranmatv(2,2);N23v=tranmatv(2,3);N24v=tranmatv(2,4);
    N31v=tranmatv(3,1);N32v=tranmatv(3,2);N33v=tranmatv(3,3);N34v=tranmatv(3,4);
    N41v=tranmatv(4,1);N42v=tranmatv(4,2);N43v=tranmatv(4,3);N44v=tranmatv(4,4);
    %draw from the dirichlet density
    p0=drchrnd([N11v+v11;N12v+v12]);
    q11=p0(1,1);
    q12=1-q11;
    q13=0;
    q14=0;
   p0=drchrnd([N22v+v22;N23v+v23]);
   q21=0;
   q22=p0(1,1);
   q23=1-q22;
   q24=0;
  
      p0=drchrnd([N33v+v33;N34v+v34]);
   q31=0;
   q32=0;
   q33=p0(1,1);
   q34=1-q33;
   
   q41=0;
   q42=0;
   q43=0;
   q44=1;
    
    


 %step 2 draw Qt
  qvec=[q11;q12;q13;q14;q21;q22;q23;q24;q31;q32;q33;q34;q41;q42;q43;q44];

  [fprobv,likx]=hamiltonfilterIDsigma4(varcoef1,varcoef1,varcoef1,varcoef1,...
      sig1,sig2,sig3,sig4,qvec,Y,X,ones(T,1));
 
 [qi,problemsv]=getS4(fprobv,qvec,ncrit,MaxTrys);
 if problemsv
   qi=q00;
 else
     q00=qi;
 end
    
    
    
    
    
    
    
    
    
    
     disp(sprintf('    Replication %s of %s  ' , ... 
             num2str([igibbs jgibbs]), num2str([ REPS filex])));
%     [problema1 problema2 problems problemsv]

    if igibbs>BURN && ~problema1 &&  ~problemsv


         jgibbs=jgibbs+1;
         % Simulate and store forward paths:
   qr_tr=reshape(qvec,4,4);

[ yhat] = getforecast4var( VarBench,HORZ,N,Y,varcoef1,sig1,sig2,sig3,sig4,fprobv,qr_tr);
 fsave(jgibbs,:,:)=yhat(L+1:end,:);
     
    bsave1(jgibbs,:)=alpha1';

   sigmaS1(jgibbs,:,:)=sig1;
   sigmaS2(jgibbs,:,:)=sig2; 
      sigmaS3(jgibbs,:,:)=sig3; 
        sigmaS4(jgibbs,:,:)=sig4;  

 
   qsave(jgibbs,:,:)=qr_tr;
   regime(jgibbs,:)=si';
   regimev(jgibbs,:)=qi';
   lik(jgibbs)=likx;
   


     end
     igibbs=igibbs+1;
end


   alpha1m=mean(bsave1);

   sig1m=squeeze(mean(sigmaS1,1));
   sig2m=squeeze(mean(sigmaS2,1));
   sig3m=squeeze(mean(sigmaS3,1));
    sig4m=squeeze(mean(sigmaS4,1));

   qm=squeeze(mean(qsave,1));
   
   varcoef1m=reshape(alpha1m,N*L+1,N);
% reshape(vec(qm),4,4)
  [fprobvm,likm]=hamiltonfilterIDsigma4(varcoef1m,varcoef1m,varcoef1m,varcoef1m,...
      sig1m,sig2m,sig3m,sig4m,vec(qm),Y,X,ones(T,1));

%compute DIC
ee=isinf(lik) | isnan(lik);
lik1=lik(ee==0);
params=mean(-2*lik1)-(-2*likm);
bdic=mean(-2*lik1)+params;