function [betadraw,delta1,sigout,resout,Qout,bdraw,cmean,cvariance]=...
    getDRAWIV2(y,x,z,sig,res,beta0,p00,Q,Q0,T0,tau0,Stau0,H0,VH0,exo,bexo,vexo,b_in)




%step 1 extract data
T=rows(y);


%step 2 draw regression coefficients
%partition omega;
sig11=sig(1,1);
sig12=sig(2,1);
sig22=sig(2,2);

%calculate conditional mean;
cmean=res(:,1)*(sig12/sig11);

%calculate conditional variance
cvariance=sig22-((sig12^2)/sig11);

%transform regressors
yc=y-exo*b_in;
ystar=(yc-cmean)./sqrt(cvariance);
xstar=x./sqrt(cvariance);

%draw beta
[betadraw,errors]=carterkohn1(beta0,p00,ones(T+1,1),Q,ystar,xstar); %TVP coefficient
%draw Q
errorq=diff(betadraw);
scaleQ=(errorq'*errorq)+Q0;
Qout=iwpq(T+T0,invpd(scaleQ));
%draw fixed coefficient
yc=y-x.*betadraw;
ystar=(yc-cmean)./sqrt(cvariance);
xstar=x./sqrt(cvariance);
bdraw=getreg(ystar,xstar,bexo,vexo,1);


%update residuals
e=y-x.*betadraw-exo*bdraw;

%draw TAU
ytilda=(y-exo*bdraw)./betadraw;
xtilda=z;

Y_SUR=([  x(:,1) ytilda]);
X_SUR=xtilda;
[delta1,temp] = KF(Y_SUR,X_SUR,sig,betadraw,tau0,Stau0);
% delta(state,:)=delta1;
%update residuals
v=x(:,1)-z*delta1';

%draw variance
%step 4 draw sigma
res=[v e];
scale=res'*res+H0;
sig=iwpq(rows(res)+VH0,inv(scale));


sigout=sig;
resout=res;