function [yhat ystar] = get_pathsTVARx(N, HORZ, T, L, Y, beta1, sigma1,beta2,tar,gam,tvar,delay)
% -------------------------------------------------------------------------
% get_paths:
% generates a matrix of simulated paths for Y for given parameters and
% general set-up (lags, horizon, etc.)
% -------------------------------------------------------------------------


% Draw N(0,1) innovations for variance and mean equation:
csigma1=chol(sigma1);



%compute forecast
LL=max(L,delay);
uu1 = randn(HORZ+LL,N);
uu2 = randn(HORZ+LL,N);
% Note we only need HORZ*N innovations, but adding an extra L draws makes 
% the indexing in the loop below a bit cleaner.

yhat=zeros(HORZ+LL,N);
%  Y(T-L+1:T,:)
yhat((LL-L)+1:(LL-L)+L,:)=Y(T-L+1:T,:);
ystar=zeros(HORZ+LL,1);
lstar=ystar;


for fi=LL+1:HORZ+LL
    
    xhat=[];
    for ji=1:L
        xhat=[xhat yhat(fi-ji,:)];
    end
    xhat=[xhat 1];
   
    ystar(fi,:)=yhat(fi-delay,tvar);
    lstar(fi,:)=1./(1+exp(-gam.*( ystar(fi,:)-tar)));
    
    e2=lstar(fi,:);
    yhat(fi,:) = ((xhat*reshape(beta1,N*L+1,N) ))+...
        ((xhat*reshape(beta2,N*L+1,N) )*e2)+...
        uu1(fi,:)*csigma1;
    
end
