function [pmat,beta_tt]=getfactorRho1_F(dataFx,Z,T,ns,H,R,beta2x,at,M,beta2m,sigmam,q1,N,L,EX,beta0,P00)

%Carter and Kohn algorithm to draw the factor
beta_tt=zeros(T,ns);          %will hold the filtered state variable
ptt=zeros(ns,ns,T);    % will hold its variance
% %%%%%%%%%%%Step 6a run Kalman Filter
i=1;
x=H;
varcoef=reshape(beta2x(i,:),N*L+EX,N);
A0=at(:,:,i);
sigma=A0*A0';
trm1=beta2m*q1*A0';
trm2=beta2m*beta2m'+sigmam;
covmat=[sigma trm1';[trm1 trm2]];
%conditional distr
[cv,cm]=transformH11(covmat,M(i,:),N);
exo=varcoef(end,:)+cm';
MU=zeros(1,ns);
MU(:,1:N)=exo;
Q=zeros(ns,ns);
Q(1:N,1:N)=cv;
F=[varcoef(1:N*L,:)' ;eye(N*(L-1),N*(L))];

%Prediction
beta10=MU+beta0*F';
p10=F*P00*F'+Q;
yhat=(x*(beta10)')';                                                
eta=[Z(i,:) dataFx(i,:)]-yhat;
feta=(x*p10*x')+R;
ifeta=invpd(feta);
%updating
K=(p10*x')*ifeta;
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);
beta_tt(i,:)=beta11;
ptt(:,:,i)=p11;

for i=2:T
varcoef=reshape(beta2x(i,:),N*L+EX,N);
A0=at(:,:,i);
sigma=A0*A0';
trm1=beta2m*q1*A0';
trm2=beta2m*beta2m'+sigmam;
covmat=[sigma trm1';[trm1 trm2]];
%conditional distr
[cv,cm]=transformH11(covmat,M(i,:),N);
exo=varcoef(end,:)+cm';
MU=zeros(1,ns);
MU(:,1:N)=exo;
Q=zeros(ns,ns);
Q(1:N,1:N)=cv;
F=[varcoef(1:N*L,:)' ;eye(N*(L-1),N*(L))];
    %Prediction
beta10=MU+beta11*F';
p10=F*p11*F'+Q;
yhat=(x*(beta10)')';  
% [Z(i,1:Ny) dataFx(i,:) Z(i,Ny+1:end)  ]
% Z(i,Ny+1:end)
eta=[Z(i,:) dataFx(i,:)]-yhat;
feta=(x*p10*x')+R;
ifeta=invpd(feta);
%updating
K=(p10*x')*ifeta;
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);
ptt(:,:,i)=p11;
beta_tt(i,:)=beta11;

end
% Backward recursion to calculate the mean and variance of the distribution of the state
%vector
beta2 = zeros(T,ns);   %this will hold the draw of the state variable
jv1=2:N; %index of state variables to extract
jv=1:N;

i=T;  %period t
p00=ptt(jv1,jv1,i); 
beta2(i,:)=beta_tt(i,:);
beta2(i,jv1)=mvnrnd(beta_tt(i:i,jv1),p00,1);%beta_tt(i:i,jv1)+(wa(i:i,jv1)*cholx(p00));   %draw for beta in period t from N(beta_tt,ptt)
%periods t-1..to .1
for i=T-1:-1:1
varcoef=reshape(beta2x(i+1,:),N*L+EX,N);
A0=at(:,:,i+1);
sigma=A0*A0';
trm1=beta2m*q1*A0';
trm2=beta2m*beta2m'+sigmam;
covmat=[sigma trm1';[trm1 trm2]];
%conditional distr
[cv,cm]=transformH11(covmat,M(i+1,:),N);
exo=varcoef(end,:)+cm';
MU=zeros(1,ns);
MU(:,1:N)=exo;
Q=zeros(ns,ns);
Q(1:N,1:N)=cv;
F=[varcoef(1:N*L,:)' ;eye(N*(L-1),N*(L))];
f=F(jv,:);
q=Q(jv,jv);
mu=MU(jv);   
    
pt=ptt(:,:,i); 
ifptfq=invpd(f*pt*f'+q);
bm=beta_tt(i:i,:)+(pt*f'*ifptfq*(beta2(i+1:i+1,jv)-mu-beta_tt(i,:)*f')')';  
pm=pt-pt*f'*ifptfq*f*pt;  
beta2(i,:)=bm;
beta2(i:i,jv1)=mvnrnd(bm(jv1),pm(jv1,jv1),1);%bm(jv1)+(wa(i:i,jv1)*cholx(pm(jv1,jv1)));  
end


pmat=beta2(:,jv1);   %update the factors