function [out,out1]=getinitialvalue1(Y,X,T0,N,L,EX)

y0=Y(1:T0,:);
x0=X(1:T0,:);
b0=x0\y0;
e0=y0-x0*b0;
sigma0=(e0'*e0)/T0;
V0=kron(sigma0,invpd(x0'*x0));
%priors for the variance of the transition equation
Q0=V0*T0*3.5e-04;  %prior for the variance of the transition equation error
P00=V0;                    % variance of the intial state vector  variance of state variable p[t-1/t-1]
beta0=vec(b0)';       % intial state vector   %state variable  b[t-1/t-1]
Q=Q0;
%priors and starting values for aij
C0=chol(sigma0);
C0=C0./repmat(diag(C0),1,N);
C0=inv(C0)';
PC0=10;
amatx=zeros(1,N*(N-1)/2);
D0=zeros(N*(N-1)/2,N*(N-1)/2);
j=1;
for i=1:N-1
    temp=C0(i+1,1:i);
amatx(1,j:j+cols(temp)-1)=temp;
D0(j:j+cols(temp)-1,j:j+cols(temp)-1)=eye(cols(temp))*(10^(-3));
j=j+cols(temp);
end
DD=D0;


%remove intial Sample
Y=Y(T0+1:end,:);
X=X(T0+1:end,:);
T=rows(X);
amat=repmat(amatx,T,1);
beta20=repmat(beta0,T,1);

%priors for the initial condition of the stochastic volatility
SS0=10;
g0=0.1^2;  %prior scale parameter for inverse gamma
g=ones(1,N).*g0;
MU0=log(diag(sigma0));
hlast=(diff(Y).^2)+0.0001;   %rough guess for stochastic volatility 
hlast=[hlast(1:2,:);hlast];  %rough intial guess for svol
Tg0=1;
e0=Y-X*(X\Y) ;
epsilon=e0*C0; %starting values for orthogonolised resids
error=e0; %starting values for VAR residuals
%50 iterations to smooth initial estimates of stochastic volatility
mm=1;
for m=1:500
  hnew=zeros(T+1,N);
  for i=1:N
      htemp=getsvolx(hlast(:,i),g(i),MU0(i),SS0,epsilon(:,i));
      hnew(:,i)=htemp;
      
  end
hlast=hnew;

g=zeros(1,N);
for i=1:N
     gerrors=diff(log(hlast(:,i)));
     g(i)=ig(gerrors,Tg0,g0);  %draw from the inverse Gamma distribution
end

[beta2,error,roots,epsilon,problem]=...
          carterkohnvarFIXED(Y,X,0,amat,hlast,ones(T,1),beta0,P00,L,0,100);
     
%  if problem
%      beta2=beta20;
%  else
%      beta20=beta2;
%  end
     
%       errorq=diff(beta2);
% scaleQ=(errorq'*errorq)+Q0;
% Q=iwpq(T+T0,pinv(scaleQ));
 j=1;
for i=2:N
    ytemp=error(:,i);
    xtemp=error(:,1:i-1)*-1;
    ytemp=(ytemp)./sqrt(hlast(2:rows(hlast),i));
    xtemp=(xtemp)./repmat(sqrt(hlast(2:rows(hlast),i)),1,cols(xtemp));
    a0=C0(i,1:i-1);
    pa=PC0*diag(abs(a0));
    Qa=DD(j:j+cols(xtemp)-1,j:j+cols(xtemp)-1);
    [a1,trash]=carterkohn1(a0,pa,ones(T+1,1),Qa,ytemp,xtemp);
    amat(:,j:j+cols(a1)-1)=a1;
    j=j+cols(a1);
end     
      
 if m>200
   MM=(N*(N+1))/2;
At=zeros(T,MM);
for t=1:T
    covx=invpd(chofac(N,amat(t,:)'))*diag(hlast(t+1,:))*invpd(chofac(N,amat(t,:)'))';
    At(t,:)=vech(logm(covx)')';
end
Atsave(mm,:,:)=At;
dAt=diff(At);
scalesave(mm,:,:)=dAt'*dAt;
mm=mm+1;
 end
      
end

out=squeeze(mean(Atsave));
out1=squeeze(mean(scalesave));