function [fprob,lik]=getlikelihoodI2(varcoef1,varcoef2,sigma1,sigma2,pp,qq,y,x)

T=rows(y);
pr_tr=kron(pp,qq);
% //           Mean   Variance
% //           0         0
% //           0         1
% //           1         0
% //           1         1

beta1=varcoef1;
beta2=varcoef1;
beta3=varcoef2;
beta4=varcoef2;
sig1=sigma1;
sig2=sigma2;
sig3=sigma1;
sig4=sigma2;

isig1=invpd(sig1);
isig2=invpd(sig2);
isig3=invpd(sig3);
isig4=invpd(sig4);
dsig1=det(sig1);
dsig2=det(sig2);
dsig3=det(sig3);
dsig4=det(sig4);
%*******************************************step 2 initialise for filter(ergodic probabiltites)r************************************@
%transition probability matrix


ett=[1;0;0;0];

%**************************************************Step 1 Filter Forward Iteration*****************@
lik=0;
fprob=zeros(T,4);
for it=1:T

em1=y(it,:)-x(it,:)*beta1;
em2=y(it,:)-x(it,:)*beta2;
em3=y(it,:)-x(it,:)*beta3;
em4=y(it,:)-x(it,:)*beta4;

neta1=(1/sqrt(dsig1))*exp(-0.5*(em1*isig1*em1'));%F(Y\S=1)
neta2=(1/sqrt(dsig2))*exp(-0.5*(em2*isig2*em2'));%F(Y\S=2)
neta3=(1/sqrt(dsig3))*exp(-0.5*(em3*isig3*em3'));%F(Y\S=3)
neta4=(1/sqrt(dsig4))*exp(-0.5*(em4*isig4*em4'));%F(Y\S=4)


%hamilton filter kim and Nelson eq 4.19 and 4.20 pg63 also see equations 22.4.5 and 22.4.6 in Hamilton
ett1=ett.*([neta1;neta2;neta3;neta4]);
fit=sum(ett1);
ett=(pr_tr*ett1)/fit;
fprob(it,:)=(ett1./fit)';
if fit>0
    lik=lik+log(fit);
else
    lik=lik-10;
end
end