function [fprob,lik]=...
hamiltonfilterIDbeta4(beta1,beta2,beta3,beta4,sigma1,sigma2,sigma3,sigma4,pvec,y,x,qt)

T=rows(y);
isig1=invpd(sigma1);
isig2=invpd(sigma2);
isig3=invpd(sigma3);
isig4=invpd(sigma4);
dsig1=det(sigma1);
dsig2=det(sigma2);
dsig3=det(sigma3);
dsig4=det(sigma4);
%*******************************************step 2 initialise for filter(ergodic probabiltites)r************************************@
%transition probability matrix

    pr_tr=reshape(pvec,4,4);
%     sum(pr_tr)

ett=[1;0;0;0];

%**************************************************Step 1 Filter Forward Iteration*****************@
lik=0;
fprob=zeros(T,4);
for it=1:T

em1=y(it,:)-x(it,:)*beta1;
em2=y(it,:)-x(it,:)*beta2;
em3=y(it,:)-x(it,:)*beta3;
em4=y(it,:)-x(it,:)*beta4;

if qt(it)==1
neta1=(1/sqrt(dsig1))*exp(-0.5*(em1*isig1*em1'));%F(Y\S=1)
neta2=(1/sqrt(dsig1))*exp(-0.5*(em2*isig1*em2'));%F(Y\S=2)
neta3=(1/sqrt(dsig1))*exp(-0.5*(em3*isig1*em3'));%F(Y\S=3)
neta4=(1/sqrt(dsig1))*exp(-0.5*(em4*isig1*em4'));%F(Y\S=4)

elseif qt(it)==2
neta1=(1/sqrt(dsig2))*exp(-0.5*(em1*isig2*em1'));%F(Y\S=1)
neta2=(1/sqrt(dsig2))*exp(-0.5*(em2*isig2*em2'));%F(Y\S=2)
neta3=(1/sqrt(dsig2))*exp(-0.5*(em3*isig2*em3'));%F(Y\S=3)
neta4=(1/sqrt(dsig2))*exp(-0.5*(em4*isig2*em4'));%F(Y\S=4)

elseif qt(it)==3
neta1=(1/sqrt(dsig3))*exp(-0.5*(em1*isig3*em1'));%F(Y\S=1)
neta2=(1/sqrt(dsig3))*exp(-0.5*(em2*isig3*em2'));%F(Y\S=2)
neta3=(1/sqrt(dsig3))*exp(-0.5*(em3*isig3*em3'));%F(Y\S=3)
neta4=(1/sqrt(dsig3))*exp(-0.5*(em4*isig3*em4'));%F(Y\S=4)

elseif qt(it)==4
neta1=(1/sqrt(dsig4))*exp(-0.5*(em1*isig4*em1'));%F(Y\S=1)
neta2=(1/sqrt(dsig4))*exp(-0.5*(em2*isig4*em2'));%F(Y\S=2)
neta3=(1/sqrt(dsig4))*exp(-0.5*(em3*isig4*em3'));%F(Y\S=3)
neta4=(1/sqrt(dsig4))*exp(-0.5*(em4*isig4*em4'));%F(Y\S=4)

end

%hamilton filter kim and Nelson eq 4.19 and 4.20 pg63 also see equations 22.4.5 and 22.4.6 in Hamilton
ett1=ett.*([neta1;neta2;neta3;neta4]);
fit=sum(ett1);
ett=(pr_tr*ett1)/fit;
fprob(it,:)=(ett1./fit)';
if fit>0
    lik=lik+log(fit);
else
    lik=lik-10;
end
end