function [fprob,lik]=hamiltonfilterIDsigma3(beta1,beta2,beta3,sigma1,sigma2,sigma3,...
    pvec,y,x,st)

T=rows(y);
isig1=invpd(sigma1);
isig2=invpd(sigma2);
isig3=invpd(sigma3);
dsig1=det(sigma1);
dsig2=det(sigma2);
dsig3=det(sigma3);
%*******************************************step 2 initialise for filter(ergodic probabiltites)r************************************@
%transition probability matrix

    pr_tr=reshape(pvec,3,3);

ett=[1;0;0];

%**************************************************Step 1 Filter Forward Iteration*****************@
lik=0;
fprob=zeros(T,3);
for it=1:T
if st(it)==1
em1=y(it,:)-x(it,:)*beta1;
em2=y(it,:)-x(it,:)*beta1;
em3=y(it,:)-x(it,:)*beta1;

elseif st(it)==2
 em1=y(it,:)-x(it,:)*beta2;
em2=y(it,:)-x(it,:)*beta2;
em3=y(it,:)-x(it,:)*beta2;

elseif st(it)==3
 em1=y(it,:)-x(it,:)*beta3;
em2=y(it,:)-x(it,:)*beta3;
em3=y(it,:)-x(it,:)*beta3;

end

neta1=(1/sqrt(dsig1))*exp(-0.5*(em1*isig1*em1'));%F(Y\S=1)
neta2=(1/sqrt(dsig2))*exp(-0.5*(em2*isig2*em2'));%F(Y\S=2)
neta3=(1/sqrt(dsig3))*exp(-0.5*(em3*isig3*em3'));%F(Y\S=3)



%hamilton filter kim and Nelson eq 4.19 and 4.20 pg63 also see equations 22.4.5 and 22.4.6 in Hamilton
ett1=ett.*([neta1;neta2;neta3]);
fit=sum(ett1);
ett=(pr_tr*ett1)/fit;
fprob(it,:)=(ett1./fit)';
if fit>0
    lik=lik+log(fit);
else
    lik=lik-10;
end
end