function [lik,fprob,sigma1,sigma2,fprobs]=hamiltonfilterML(THETA,y,x,N,L)
NN=N*(N*L+1);
NN1=(N*(N+1))/2;
 beta1=reshape(THETA(1:NN,:),N*L+1,N);
 beta2=reshape(THETA(NN+1:NN*2,:),N*L+1,N);

A1=chofac1(N,THETA((NN*2)+1:(NN*2)+NN1))';
A2=chofac1(N,THETA((NN*2)+NN1+1:end-1))';
sigma1=A1'*A1;
sigma2=A2'*A2;
g1=THETA(rows(THETA));

p=exp(g1)/(1+exp(g1));
q=1;
T=rows(y);
isig1=invpd(sigma1);
isig2=invpd(sigma2);
dsig1=det(sigma1);
dsig2=det(sigma2);
%*******************************************step 2 initialise for filter(ergodic probabiltites)r************************************@
%transition probability matrix

    pr_tr=[p (1-q); (1-p) q];


ett=[1;0];

%**************************************************Step 1 Filter Forward Iteration*****************@
lik=0;
fprob=zeros(T,2);
for it=1:T

em1=y(it,:)-x(it,:)*beta1;
em2=y(it,:)-x(it,:)*beta2;
neta1=(1/sqrt(dsig1))*exp(-0.5*(em1*isig1*em1'));%F(Y\S=1)
neta2=(1/sqrt(dsig2))*exp(-0.5*(em2*isig2*em2'));%F(Y\S=2)

%hamilton filter kim and Nelson eq 4.19 and 4.20 pg63 also see equations 22.4.5 and 22.4.6 in Hamilton
ett1=ett.*([neta1;neta2]);
fit=sum(ett1);
ett=(pr_tr*ett1)/fit;
fprob(it,:)=(ett1./fit)';
if fit>0
    lik=lik+log(fit);
else
    lik=lik-10;
end
    
end
lik=-lik;

fprobs=smoothx(fprob,pr_tr);