function [ lik,states ] = particlefilter( y,varcoef,iamat,hmat,dofmat,npart,T,N,L,EX,B00,P00,scle)
%matrices of the state space
[F,MU]=comp(varcoef,N,L,EX);
NS=cols(F);
R=eye(N)*scle;
iR=invpd(R);
detR=det(R);
H=eye(N,NS);
lik=0;
states=zeros(T,NS);
%initial state
b0=repmat(B00,npart,1)+[randn(npart,N) zeros(npart,NS-N)]*chol(P00);
for i=1:T
    
    dens=zeros(npart,1);
	bnew=zeros(npart,NS);
    for j=1:npart
        %draw states
        epsilon=zeros(1,N);
        for jj=1:N
            epsilon(1,jj)=trnd(dofmat(jj),1,1).*sqrt(hmat(jj));
        end
        %compute reduced form residuals
        reduced=epsilon*iamat';
        
        errors=zeros(1,NS);
        errors(1,1:N)=reduced;
        %new states
        
        bnew(j,:)=MU'+b0(j,:)*F'+errors;
        %density
        
        res=y(i,:)-(H*bnew(j,:)')';
        res2=res*iR*res';
	tempdens=(1/sqrt(detR))*exp(-0.5*res2);
    if isnan(tempdens) || isinf(tempdens) || ~isreal(tempdens)
        dens(j)=exp(-100);
disp(sprintf('warning= %s ', num2str([jj j])));

    else
        dens(j)=tempdens;
    end
    end
    sdens=sum(dens);
   prob=dens./sdens;
   index1=discretesample(prob,npart);
   
   b0=bnew(index1,:);
   liki=sdens/npart;
lik=lik+log(liki);
states(i,:)=sum(b0.*repmat(prob,1,NS))';
end

