function [ lik,states,hstates,astates,bstates ] = particlefilter2(y,Qx,Qax,Qmat,Fmat,npart,T,N,L,EX,B00,P00,scle,B00h,P00h,B00a,P00a,B00b,P00b)
NS=cols(B00);

R=eye(N)*scle;
iR=invpd(R);
detR=det(R);
H=eye(N,NS);
Cqmat=chol(Qmat);
CQx=chol(Qx);
CQax=chol(Qax);

	lik=0;
	states=zeros(T,NS);
    hstates=zeros(T,N);
    astates=zeros(T,cols(Qax));
    bstates=zeros(T,cols(Qx));
    
    h0=repmat(B00h,npart,1)+randn(npart,N)*chol(P00h);
   as0=repmat(B00a,npart,1)+randn(npart,cols(Qax))*chol(P00a);
    bs0=repmat(B00b,npart,1)+randn(npart,cols(Qx))*chol(P00b);
    b0=repmat(B00,npart,1)+[randn(npart,N) zeros(npart,NS-N)]*chol(P00);
	
    for i=1:T  %loop through time
	%draw particles
    hpart=randn(npart,N);
    apart=randn(npart,cols(Qax));
    bpart=randn(npart,cols(Qx));
    
	dens=zeros(npart,1);
	
	bnew=zeros(npart,NS);
	hnew=zeros(npart,N);
    aanew=zeros(npart,cols(Qax));
    bbnew=zeros(npart,cols(Qx));
    for j=1:npart
        
	
    %draw volatility states
	htemp=(h0(j,:)*Fmat')+hpart(j,:)*Cqmat;
    %draw A states
    atemp=as0(j,:)+apart(j,:)*CQax;
    %draw B states
    btemp=bs0(j,:)+bpart(j,:)*CQx;

	hnew(j,:)=htemp;
    aanew(j,:)=atemp;
    bbnew(j,:)=btemp;
    %draw data states
        epsilon=zeros(1,N);
        for jj=1:N
            epsilon(1,jj)=randn(1,1).*sqrt(exp(htemp(jj)));
        end
    %compute reduced form residuals
        amat=chofac(N,atemp');
        iamat=invpd(amat);
        reduced=epsilon*iamat';

    errors=zeros(1,NS);
    errors(1,1:N)=reduced;
 
   [F,MU]=comp(btemp,N,L,EX);
    bnew(j,:)=MU'+b0(j,:)*F'+errors;
	
	%compute conditional likelihood
	res=y(i,:)-(H*bnew(j,:)')';
        res2=res*iR*res';
	tempdens=(1/sqrt(detR))*exp(-0.5*res2);
	 if isnan(tempdens) || isinf(tempdens) || ~isreal(tempdens)
        dens(j)=exp(-100);
disp(sprintf('warning= %s ', num2str([jj j])));

    else
        dens(j)=tempdens;
    end
    end
sdens=sum(dens);
prob=dens./sdens;
index1=discretesample(prob,length(prob));
b0=bnew(index1,:);
h0=hnew(index1,:);
bs0=bbnew(index1,:);
as0=aanew(index1,:);
liki=sdens/npart;
lik=lik+log(liki);

states(i,:)=sum(b0.*repmat(prob,1,NS))';
hstates(i,:)=sum(h0.*repmat(prob,1,N))';
astates(i,:)=sum(as0.*repmat(prob,1,cols(Qax)))';
bstates(i,:)=sum(bs0.*repmat(prob,1,cols(Qx)))';

    end

end