function [ lik,hstates,astates,bstates ] = particlefilter3(y,x,Qx,Qax,Qmat,Fmat,lamdamat,npart,T,N,L,EX,B00h,P00h,B00a,P00a,B00b,P00b)



Cqmat=chol(Qmat);
CQx=chol(Qx);
CQax=chol(Qax);

	lik=0;
    hstates=zeros(T,N);
    astates=zeros(T,cols(Qax));
    bstates=zeros(T,cols(Qx));
    
    h0=repmat(B00h,npart,1)+randn(npart,N)*chol(P00h);
   as0=repmat(B00a,npart,1)+randn(npart,cols(Qax))*chol(P00a);
    bs0=repmat(B00b,npart,1)+randn(npart,cols(Qx))*chol(P00b);
	
    for i=1:T  %loop through time
	%draw particles
    hpart=randn(npart,N);
    apart=randn(npart,cols(Qax));
    bpart=randn(npart,cols(Qx));
    
	dens=zeros(npart,1);
	

	hnew=zeros(npart,N);
    aanew=zeros(npart,cols(Qax));
    bbnew=zeros(npart,cols(Qx));
    for j=1:npart
        
	
    %draw volatility states
	htemp=(h0(j,:)*Fmat')+hpart(j,:)*Cqmat;
    %draw A states
    atemp=as0(j,:)+apart(j,:)*CQax;
    %draw B states
    btemp=bs0(j,:)+bpart(j,:)*CQx;
    varcoef=reshape(btemp,N*L+EX,N);
	hnew(j,:)=htemp;
    aanew(j,:)=atemp;
    bbnew(j,:)=btemp;
    HH=diag(exp(htemp).*(1./lamdamat(i,:)));
    amat=chofac(N,atemp');
    iamat=invpd(amat);
    R=iamat*HH*iamat';
    iR=invpd(R);
     detR=det(R);
    
  res=y(i,:)-x(i,:)*varcoef;
 

	
	%compute conditional likelihood

        res2=res*iR*res';
	tempdens=(1/sqrt(detR))*exp(-0.5*res2);
	 if isnan(tempdens) || isinf(tempdens) || ~isreal(tempdens)
        dens(j)=exp(-100);
disp(sprintf('warning= %s ', num2str([jj j])));

    else
        dens(j)=tempdens;
    end
    end
sdens=sum(dens);
prob=dens./sdens;
index1=discretesample(prob,length(prob));

h0=hnew(index1,:);
bs0=bbnew(index1,:);
as0=aanew(index1,:);
liki=sdens/npart;
lik=lik+log(liki);


hstates(i,:)=sum(h0.*repmat(prob,1,N))';
astates(i,:)=sum(as0.*repmat(prob,1,cols(Qax)))';
bstates(i,:)=sum(bs0.*repmat(prob,1,cols(Qx)))';

    end

end