function [ lik,hstates,astates ] = ...
    pfiltersvol(y,x,beta2,Qax,Qmat,Fmat,npart,T,N,L,EX,B00h,P00h,B00a,P00a)



Cqmat=chol(Qmat);

CQax=chol(Qax);

	lik=0;
    hstates=zeros(T,N);
    astates=zeros(T,cols(Qax));
    
    h0=repmat(B00h,npart,1)+randn(npart,N)*chol(P00h);
   as0=repmat(B00a,npart,1)+randn(npart,cols(Qax))*chol(P00a);
varcoef=reshape(beta2,N*L+EX,N);	
    for i=1:T  %loop through time
        yy=y(i,:);
        xx=x(i,:);
	%draw particles
    hpart=randn(npart,N);
    apart=randn(npart,cols(Qax));
    
	densL=zeros(npart,1);
	

	hnew=zeros(npart,N);
    aanew=zeros(npart,cols(Qax));
    parfor j=1:npart
        
	
    %draw volatility states
	htemp=(h0(j,:)*Fmat')+hpart(j,:)*Cqmat;
    %draw A states
    atemp=as0(j,:)+apart(j,:)*CQax;
    %draw B states
 
	hnew(j,:)=htemp;
    aanew(j,:)=atemp;
    
    HH=diag(exp(htemp));
    amat=chofac(N,atemp');
    iamat=invpd(amat);
    R=iamat*HH*iamat';
    iR=invpd(R);
     detR=logdet(R);
    
  res=yy-xx*varcoef;
 

	
	%compute conditional likelihood

        res2=res*iR*res';
        
        
        denslog=-0.5*detR+(-0.5*res2)    ;

tempdens=(denslog);
    if isnan(tempdens) || isinf(tempdens) || ~isreal(tempdens)
        densL(j)=-10;
    else
        densL(j)=tempdens;
    end
        
    end
 [densexp,sfactor]=safeexp(densL);
    sdens=sum(densexp);
    if sdens==0 || isinf(sdens)
        lik=-999;
        problem=1;
        return
    end
        
   prob=densexp./sdens;
 
   index1=discretesample(prob,npart);
h0=hnew(index1,:);
as0=aanew(index1,:);
liki=sdens/npart;
lik=lik+(log(liki)+sfactor);
% unique(index1)


hstates(i,:)=sum(h0.*repmat(prob,1,N))';
astates(i,:)=sum(as0.*repmat(prob,1,cols(Qax)))';

    end

end