
function [beta,BB,W,problem]=pftest7Fr(F,fitin,sigma,xfix,hlast,amat,y,x,xm,bm,sm,NS,B00,N,Nx,L,EX)
%
q=sigma;
iq=invpd(q);
cq=chol(q);
iQ=iq;
cQ=cq;
T=size(y,1);
problem=zeros(T,1);

beta=zeros(T,NS,N); %will hold filtered state variable
beta(1,:,:)=repmat(B00',1,N); %fixed initial condition
BB=zeros(N,T); %ancestor indices 
W=zeros(N,T); %weights
beta(1,:,N)=xfix(1,:);
for t=1:T
 
if (t~=1)
  
     fit=fitin;
    index=discretesample(W(:,t-1),N);
    index=index(randperm(N));
 
    [betahat,m]=xpred(beta(t-1,:,:),F,fit,xfix(t,:),iQ);
  
    %draw particles
    for j=1:N
        
    beta(t,:,j)=betahat(:,:,index(j))+randn(1,NS)*cQ;
    end
    %conditioned particle
    beta(t,:,N)=xfix(t,:);
    %sample ancestors
    was=m.*W(:,t-1);
    probas=was./sum(was);
    if sum(was)==0 || any(isnan(probas))
       problem(t)=1;
       index(N)=1;
   else
    index(N)=discretesample(probas,1);%find(rand(1) < cumsum(probas),1,'first');%discretesample(probas,1);
    end
    BB(:,t)=index';
end

%compute importance weights
logweights=zeros(1,N);
xvar=ones(1,Nx*L+EX);
xvar(:,1:Nx*L)=x(t,1:cols(x)-1);
for j=1:N
beta1=(beta(t,:,j)); 
B=reshape(beta1,Nx*L+EX,Nx);
Hs2=diag(hlast(t,:));
A2=chofac(Nx,amat(t,:)');
iA2=invpd(A2);
R=iA2*Hs2*iA2';
rc=rcond(R);
res=y(t,:)-xvar*B;
if rc<1e-14 
res2=res*pinv(R)*res';
else
res2=res/R*res';
end
ldetR=logdetx(R);
lik2=-0.5*ldetR+(-0.5*res2);
%likelihood for instrument eq
Rm=diag(sm);
resm=res-xm(t,:)*reshape(bm(t,:),2,Nx);
resm2=resm/Rm*resm';
ldetRm=logdetx(Rm);
likm=-0.5*ldetRm+(-0.5*resm2);
logweights(j)=lik2+likm;%logweights(j)=log((1/sqrt(detR)))+(-0.5*res2);
end
const = max(logweights); % Subtract the maximum value for numerical stability
weights = exp(logweights-const);
W(:,t)=weights./sum(weights);


end


% Generate the trajectories from ancestor indices
index = BB(:,T);
for t = T-1:-1:1
    beta(t,:,:) = beta(t,:,index);
    index = BB(index,t);
end
end

function [out,dens]= xpred(beta,F,fit,x,iQ)
N=size(beta,3);
NS=size(beta,2);
out=zeros(1,NS,N);
dens=zeros(N,1);
mu=zeros(1,NS);
mu(:,1:cols(fit))=fit;
for j=1:N

 fitx= (beta(:,:,j))*F'+mu;
 res=fitx-x;
 densx=exp(-0.5*res*iQ*res');
 %squeeze(betahat(:,:,index))'+randn(N,NS)'*cQ
out(:,:,j)=fitx;
dens(j,:)=densx;
end

end

