function[scale,epsilonout,hlastout,dofout]= rungibbs(T,N,EX,index,REPS,BURN,epsilon,hlast,dof,dofold,scale,v0,Tg0,g0,MU0,BETA0,SIGMA0,HORZ,L,res,Y,X,CHECK,maxdraws)
naccept=zeros(1,N);

tic;
gibbs2=1;
gibbs1=1;
Q=zeros(N*(N*L+1),N*(N*L+1));
for gibbs=1:REPS
%Gibbs Step 1:draw lamdai for each variable
lamda=zeros(T,N);
for i=1:N
lamda(:,i)=getlamda( epsilon(:,i),hlast(:,i),dof(i) );
end

%Gibbs step 2:draw dof
dofnew=zeros(1,N);
nacceptout=zeros(1,N);
for i=1:N
[ dofnew(i),nacceptout(i) ] = drawdof( dofold(i),scale(i),lamda(:,i),T,v0 );
end
dofold=dofnew;
dof=dofold;
naccept=naccept+nacceptout;
arate=naccept./gibbs;
if gibbs>200
for aa=1:length(arate)
    if arate(aa)<0.35
        scale(aa)=scale(aa).*0.99;
    end
    if arate(aa)>0.55
        scale(aa)=scale(aa).*1.01;
    end
end
end  

%gibbs step 3: draw gmat
g=zeros(1,N);
for i=1:N
     gerrors=diff(log(hlast(:,i)));
     g(i)=ig(gerrors,Tg0,g0);  %draw from the inverse Gamma distribution
end

%sample stochastic vol for each epsilon using the MH algorithm in Jaquier
    %Polson and Rossi
      hnew=zeros(T+1,N);
      for i=1:N
          resids1=epsilon(:,i).*sqrt(lamda(:,i));
          htemp=getsvol(hlast(:,i),g(i),MU0(i),resids1); 
          hnew(:,i)=htemp;
      end
    hlast=hnew;


%gibbs step 4: draw elements of the A matrix
amatx=[];
for j=2:N
%v2=-a1*v1+sqrt(h2*w)*e2
ytemp=res(:,j);  %v2
xtemp=res(:,1:j-1)*(-1); %-v1
ytemp=(ytemp.*sqrt(lamda(:,j)))./sqrt(hlast(2:rows(hlast),j));
xtemp=(xtemp.*repmat(sqrt(lamda(:,j)),1,cols(xtemp)))./repmat(sqrt(hlast(2:rows(hlast),j)),1,cols(xtemp));
A0=zeros(cols(xtemp),1);
V0=eye(cols(xtemp))*1000;
alpha21_2=getreg(ytemp,xtemp,A0,V0,1); %draw from Normal

amatx=[amatx alpha21_2'];
end
iamat=invpd(chofac(N,amatx'));%chofac converts to a lower triangular 

%gibbs step 5: draw the VAR coefficients
[beta2,res,roots,problem]=carterkohnvar(Y,X,Q,iamat,hlast,lamda,BETA0',SIGMA0,L,CHECK,maxdraws,EX);
if problem
    beta2=b0;
else
    b0=beta2;
end
epsilon=res*invpd(iamat)'; 
disp(sprintf('Iteration Number= %s acceptance rates= %s', num2str(gibbs),num2str(arate)));

if gibbs>BURN
    

gibbs1=gibbs1+1;

if sum(gibbs==index)
    
    gibbs1=1;
    gibbs2=gibbs2+1;
 end



end
end
epsilonout=epsilon;
hlastout=hlast;
dofout=dof;