function [fsave,bdic,bsave1,bsave2,sigmaS1,sigmaS2,tsave]=runtvar(datain,L,lamdaP,tauP,epsilonP,tarvar,TARD,tarvariance,tarscalein,REPS,BURN,Update,MaxTrys,HORZ,dp,dte)  

data=packr(datain);

%find 'optimal' tarscalein
[tarscale]=tvartrialrun(data,L,lamdaP,tauP,epsilonP,tarvar,TARD,tarvariance,tarscalein,1000,400,Update,MaxTrys,HORZ,dp);  

tard=1:TARD;





Y=packr(data);
N=cols(Y);
ncrit=(N*L+1);

%take lags
X=[];
for j=1:L
X=[X lag0(data,j) ];
end
X=[X ones(rows(X),1)];

%compute threshold variable
Ystar=lag0(Y(:,tarvar),tard(1));


Y=Y(max([L,tard(1)])+1:end,:);
X=X(max([L,tard(1)])+1:end,:);
Ystar=Ystar(max([L,tard(1)])+1:end,:);
tarmean=mean(Ystar);  %mean of the prior on the threshold is the mean value of the threshold variable

% Additional priors for VAR coefficients
muP=mean(Y)';
sigmaP=[];
deltaP=[];
e0=[];
for i=1:N
    ytemp=Y(:,i);
    xtemp=[lag0(ytemp,1) ones(rows(ytemp),1)];
    ytemp=ytemp(2:end,:);
    xtemp=xtemp(2:end,:);
    btemp=xtemp\ytemp;
    etemp=ytemp-xtemp*btemp;
    stemp=etemp'*etemp/rows(ytemp);
    if abs(btemp(1))>1
        btemp(1)=1;
    end
    deltaP=[deltaP;btemp(1)];
    sigmaP=[sigmaP;stemp];
    e0=[e0 etemp];
end

%dummy data to implement priors see http://ideas.repec.org/p/ecb/ecbwps/20080966.html
[yd,xd] = create_dummies(lamdaP,tauP,deltaP,epsilonP,L,muP,sigmaP,N);


T=rows(Y);


fsave=zeros(REPS-BURN,HORZ,N); 
jgibbs=1;

% Display empty line (to separate samples in the screen shot)
disp(sprintf(' ')) 


  Y0=[Y;yd];
  X0=[X;xd];
  
  sigma1=eye(N); %starting value for sigma
  sigma2=eye(N);
  beta0=vec(X0\Y0);
  beta01=beta0;
  beta02=beta0;
  tar=tarmean; %initial value of the threshold 
  tarold=tar;
  naccept=0;
  b0filter=[Y(1,:) X(1,1:cols(X)-(N+1))];
  p0filter=eye(cols(b0filter)).*0.00000001;
  
  naccept=0;
  igibbs=1;
  jgibbs=0;
while jgibbs<REPS-BURN
	
    
    
    %step 1: Seperate into two regimes
    e1=Ystar<=tar;
    e2=Ystar>tar;
    
    Y1=Y(e1,:);
    X1=X(e1,:);
    
    Y2=Y(e2,:);
    X2=X(e2,:);
    
    %step 2 Sample Coefficients and variance regime 1
    
    Y0=[Y1;yd];
    X0=[X1;xd];
  %conditional mean of the VAR coefficients
  mstar1=vec(X0\Y0);  %ols on the appended data
  xx=X0'*X0;
  ixx1=xx\eye(cols(xx));
   [ beta1,PROBLEM1] = getcoef( mstar1,sigma1,ixx1,MaxTrys,N,L );
     if PROBLEM1
         beta1=beta01;
     else
         beta01=beta1;
     end
     
     %draw covariance
     e=Y0-X0*reshape(beta1,N*L+1,N);
    scale=e'*e;
    sigma1=iwpq(rows(Y0),inv(scale));  
    
    
    %step 3 Sample Coefficients and variance in regime 2
    
     Y0=[Y2;yd];
    X0=[X2;xd];
  %conditional mean of the VAR coefficients
  mstar2=vec(X0\Y0);  %ols on the appended data
  xx=X0'*X0;
  ixx2=xx\eye(cols(xx));
   [ beta2,PROBLEM2] = getcoef( mstar2,sigma2,ixx2,MaxTrys,N,L );
     if PROBLEM2
         beta2=beta02;
     else
         beta02=beta2;
     end
     
     %draw covariance
     e=Y0-X0*reshape(beta2,N*L+1,N);
    scale=e'*e;
    sigma2=iwpq(rows(Y0),inv(scale)); 
    
    
    
    %step 4 Sample Threshold via a Random Walk Metropolis Step
    
    tarnew=tarold+randn(1,1)*sqrt(tarscale);
     %compute conditional posterior at the old and new draw

      postnew=getvarpost(Y,X,beta1,beta2,sigma1,sigma2,L,tarnew,tarmean,tarvariance,Ystar,ncrit);
      postold=getvarpost(Y,X,beta1,beta2,sigma1,sigma2,L,tarold,tarmean,tarvariance,Ystar,ncrit);

     accept=exp(postnew-postold);
     u=rand(1,1);
     if u<accept
         tarold=tarnew;
         naccept=naccept+1;
     end
     tar=tarold;
     arate=naccept/igibbs;
     
     %step 5 sample delay parameter
     prob=[];
     for jj=1:length(tard)
         [yy,xx,yys]=prepareT( data,L,tard(jj),tarvar );
         
         postx=getvarpost(yy,xx,beta1,beta2,sigma1,sigma2,L,tar,tarmean,tarvariance,yys,ncrit);
         prob=[prob postx];
     end
     prob=safeexp(prob);
     prob=prob/sum(prob);
     
     %draw delay
     index=discretesample(prob,1);
     %update data
     [Y,X,Ystar]=prepareT( data,L,tard(index),tarvar );
     
     
     
     if dp
    % Display progress:
    if mod(igibbs,Update)==0 
        disp(sprintf('     Replication %s of %s acceptance %s. delay is %s. date %s', ... 
             num2str(igibbs), num2str(REPS),num2str(arate),num2str(tard(index)),dte ));
    end 
     end
     

    

     if igibbs>BURN && ~PROBLEM1 &&~ PROBLEM2
         jgibbs=jgibbs+1;
         % Simulate and store forward paths:
      [~,lik1,lik2]=getvarpost(Y,X,beta1,beta2,sigma1,sigma2,L,tar,tarmean,tarvariance,Ystar,ncrit);
lik(jgibbs)=lik1+lik2;
  yhat=get_pathsTVAR(N, HORZ, rows(Y), L, Y, beta1, sigma1,beta2,sigma2,tar,tarvar,tard(index));
  
         fsave(jgibbs,:,:)=yhat(max(L,tard(index))+1:end,:);
   bsave1(jgibbs,:)=beta1';
   bsave2(jgibbs,:)=beta2';
   sigmaS1(jgibbs,:,:)=sigma1;
   sigmaS2(jgibbs,:,:)=sigma2;   
   tsave(jgibbs,:)=[tar tard(index)];

     end
     igibbs=igibbs+1;
end


b1m=mean(bsave1);
b2m=mean(bsave2);
s1m=squeeze(mean(sigmaS1));
s2m=squeeze(mean(sigmaS2));
tmean=mean(tsave);
     [Y,X,Ystar]=prepareT( data,L,tmean(2),tarvar );

      [~,lik1m,lik2m]=...
          getvarpost(Y,X,b1m,b1m,s1m,s2m,L,tmean(1),tarmean,tarvariance,Ystar,ncrit);
likm=lik1m+lik2m;

%compute DIC
ee=isinf(lik) | isnan(lik);
lik1=lik(ee==0);
params=mean(-2*lik1)-(-2*likm);
bdic=mean(-2*lik1)+params;

