
function [beta,BB,W,problem]=testIWPF(xfix,y,nu,NS,B00,N)
%

T=size(y,1);
problem=zeros(T,1);

beta=zeros(NS,NS,T,N); %will hold filtered state variable
for j=1:N
beta(:,:,1,j)=B00; %fixed initial condition
end
BB=zeros(N,T); %ancestor indices 
W=zeros(N,T); %weights
beta(:,:,1,N)=xfix(:,:,1);
for t=1:T
 
if (t~=1)
  
     
    index=discretesample(W(:,t-1),N);
    index=index(randperm(N));
 
    [betahat,m]=xpred(beta(:,:,t-1,:),xfix(:,:,t),nu);%xpred(beta(t-1,:,:),F,fit,xfix(t,:),iQ);
 
    %draw particles
    for j=1:N    
    beta(:,:,t,j)=iwpq1(nu,betahat(:,:,index(j)));%+randn(1,NS)*cQ;
    end
    %conditioned particle
    beta(:,:,t,N)=xfix(:,:,t);
    %sample ancestors
    was=m.*W(:,t-1);
    probas=was./sum(was);
    if sum(was)==0 || any(isnan(probas))
       problem(t)=1;
       index(N)=1;
   else
    index(N)=discretesample(probas,1);%find(rand(1) < cumsum(probas),1,'first');%discretesample(probas,1);
    end
    BB(:,t)=index';
end

%compute importance weights
logweights=zeros(1,N);

for j=1:N
R=(beta(:,:,t,j));


rc=rcond(R);
res=y(t,:);
if rc<1e-14 
res2=res*pinv(R)*res';
else
res2=res/R*res';
end
ldetR=logdetx(R);
lik2=-0.5*ldetR+(-0.5*res2);
logweights(j)=lik2;
end
const = max(logweights); % Subtract the maximum value for numerical stability
weights = exp(logweights-const);
W(:,t)=weights./sum(weights);


end


% Generate the trajectories from ancestor indices
index = BB(:,T);
for t = T-1:-1:1
    beta(:,:,t,:) = beta(:,:,t,index);
    index = BB(index,t);
end
end

function [out,dens]= xpred(beta,xfix,nu)
N=size(beta,4);
NS=size(beta,1);
out=zeros(NS,NS,1,N);
dens=zeros(N,1);

for j=1:N

 fitx= (beta(:,:,1,j));
 
 densx=exp(invwishpdf(fitx,xfix,nu));
 %squeeze(betahat(:,:,index))'+randn(N,NS)'*cQ
out(:,:,j)=fitx;
dens(j,:)=densx;
end

end

